grammar Genea1 ;

nonterminal Geneology, Families, Family, Parents, Parent; 

synthesized attribute report :: String ;

attribute report occurs on Geneology, Families, Family, Parents, Parent; 

concrete production geneology
g::Geneology ::= fs::Families
{ g.report = "\n" ++ fs.report ++ "\n\n" ;
}

concrete production oneFamily
fs::Families ::= f::Family
{ fs.report = f.report ;
}

concrete production consFamily
fs::Families ::= f::Family rest::Families
{ fs.report = f.report ++ "\n" ++ rest.report ;
}

concrete production family
f::Family ::= p::Parents cs::Children
{ f.report = p.report ++ cs.report ;
}

concrete production parents
p::Parents ::= '(' p1::Parent ',' p2::Parent ')' 
{ p.report = "Parents: " ++ p1.report ++ "\n     and " ++ p2.report ++ "\n" ;
}

concrete production parent
p::Parent ::= first::FirstName last::LastName g::Gender birth::Year
{ p.report = first.report ++ " " ++ last.report ++ " (" ++ g.report ++ "), " ++
             "born in " ++ birth.report ; }


