grammar Genea4 ;

nonterminal Geneology, Families, Family, Parents, Parent; 

synthesized attribute report :: String ;

attribute report occurs on Geneology, Families, Family, Parents, Parent; 

synthesized attribute isCorrect :: Boolean ;
attribute isCorrect occurs on Geneology, Families, Family ; -- Parents, Parent; 

synthesized attribute youngestBirthYear :: Integer ;
attribute youngestBirthYear occurs on Parent, Parents ;

concrete production geneology
g::Geneology ::= fs::Families
{ g.report = "\n" ++ fs.report ++ "\n\n" ;
  g.isCorrect = fs.isCorrect ;
}

concrete production oneFamily
fs::Families ::= f::Family
{ fs.report = f.report ;
  fs.isCorrect = f.isCorrect ;
}

concrete production consFamily
fs::Families ::= f::Family rest::Families
{ fs.report = f.report ++ "\n" ++ rest.report ;
  fs.isCorrect = f.isCorrect && rest.isCorrect ;
}

concrete production family
f::Family ::= p::Parents cs::Children
{ f.report = p.report ++ cs.report ;
  f.isCorrect = cs.numChildren == 0
                || (p.youngestBirthYear + 15 < cs.oldestBirthYear) ;
}

concrete production parents
p::Parents ::= '(' p1::Parent ',' p2::Parent ')' 
{ p.report = "Parents: " ++ p1.report ++ "\n     and " ++ p2.report ++ "\n" ;
  p.youngestBirthYear = if p1.youngestBirthYear < p2.youngestBirthYear
                        then p1.youngestBirthYear
                        else p2.youngestBirthYear ;
}

concrete production parent
p::Parent ::= first::FirstName last::LastName g::Gender birth::Year
{ p.report = first.report ++ " " ++ last.report ++ " (" ++ g.report ++ "), " ++
             "born in " ++ birth.report ; 
  p.youngestBirthYear = birth.year ;
}


