grammar Genea6 ;

nonterminal Children, ChildList, Child ;

attribute report occurs on Children, ChildList, Child ;
attribute errors occurs on  Children, ChildList, Child ;

synthesized attribute numChildren :: Integer occurs on ChildList, Children ;
synthesized attribute oldestBirthYear :: Integer occurs on ChildList, Children ;
synthesized attribute birthYear :: Integer occurs on Child ;

concrete production noChildren
cs::Children ::= 
{ cs.report = " No children.\n" ;
  cs.numChildren = 0 ;
  cs.oldestBirthYear = -1 ;
  cs.errors = "" ;
}

concrete production someChildren
cs::Children ::= '{' cl::ChildList '}'
{ cs.report = " Children: (" ++ toString(cl.numChildren) ++
              " oldest born in " ++ toString(cl.oldestBirthYear) ++
              ")\n" ++ 
              cl.report ;
  cs.numChildren = cl.numChildren ;
  cs.oldestBirthYear = cl.oldestBirthYear ;
  cl.earliestPossibleBirthYear = cs.earliestPossibleBirthYear ;
  cs.errors = cl.errors ;
}

concrete production oneChild
cl::ChildList ::= c::Child
{ cl.report = c.report ;
  cl.numChildren = 1;
  cl.oldestBirthYear = c.birthYear ;
  c.earliestPossibleBirthYear = cl.earliestPossibleBirthYear ;
  cl.errors = c.errors ;
}

concrete production consChild
cl::ChildList ::= c::Child ',' rest::ChildList
{ cl.report = c.report ++ rest.report ;
  cl.numChildren = 1 + rest.numChildren ;
  cl.oldestBirthYear = if   c.birthYear < rest.oldestBirthYear
                       then c.birthYear
                       else rest.oldestBirthYear ;

  c.earliestPossibleBirthYear = cl.earliestPossibleBirthYear ;
  rest.earliestPossibleBirthYear = cl.earliestPossibleBirthYear ;
  cl.errors = c.errors ++ rest.errors ;
}

concrete production child
c::Child ::= n::FirstName g::Gender birth::Year
{ c.report = "  " ++ n.report ++ " (" ++ g.report ++ "), " ++
             "born in " ++ birth.report ++ "\n" ;
  c.birthYear = birth.year ;
  c.errors = if c.earliestPossibleBirthYear > birth.year
             then "Error: Child \"" ++ n.report ++ 
                  "\" has incorrect (too early) birth year of " ++
                  toString(birth.year) ++ ".\n" 
             else "" ;
                
}

