grammar Genea6 ;

nonterminal Geneology, Families, Family, Parents, Parent; 

synthesized attribute report :: String ;

attribute report occurs on Geneology, Families, Family, Parents, Parent; 

synthesized attribute isCorrect :: Boolean ;
attribute isCorrect occurs on Geneology, Families, Family ; -- Parents, Parent; 

synthesized attribute errors :: String ;
attribute errors occurs on Geneology, Families, Family ; -- Parents, Parent; 

synthesized attribute youngestBirthYear :: Integer ;
attribute youngestBirthYear occurs on Parent, Parents ;

inherited attribute earliestPossibleBirthYear :: Integer 
  occurs on Children, ChildList, Child ;

concrete production geneology
g::Geneology ::= fs::Families
{ g.report = "\n" ++ fs.report ++ "\n\n" ;
  g.isCorrect = fs.isCorrect ;
  g.errors = fs.errors ;
}

concrete production oneFamily
fs::Families ::= f::Family
{ fs.report = f.report ;
  fs.isCorrect = f.isCorrect ;
  fs.errors = f.errors ;
}

concrete production consFamily
fs::Families ::= f::Family rest::Families
{ fs.report = f.report ++ "\n" ++ rest.report ;
  fs.isCorrect = f.isCorrect && rest.isCorrect ;
  fs.errors = f.errors ++ rest.errors ;
}

concrete production family
f::Family ::= p::Parents cs::Children
{ f.report = p.report ++ cs.report ;
  f.isCorrect = cs.errors == "" ;

--  f.errors = if cs.numChildren == 0
--                || (p.youngestBirthYear + 15 < cs.oldestBirthYear) 
--             then ""
--             else "Error: One of the parents \n" ++ p.report ++ "\n    " ++
--                  "was born less than 15 years before the oldest child.\n\n" ;

  cs.earliestPossibleBirthYear = p.youngestBirthYear + 15 ;
  f.errors = cs.errors ;
}

concrete production parents
p::Parents ::= '(' p1::Parent ',' p2::Parent ')' 
{ p.report = "Parents: " ++ p1.report ++ "\n     and " ++ p2.report ++ "\n" ;
  p.youngestBirthYear = if p1.youngestBirthYear < p2.youngestBirthYear
                        then p1.youngestBirthYear
                        else p2.youngestBirthYear ;
}

concrete production parent
p::Parent ::= first::FirstName last::LastName g::Gender birth::Year
{ p.report = first.report ++ " " ++ last.report ++ " (" ++ g.report ++ "), " ++
             "born in " ++ birth.report ; 
  p.youngestBirthYear = birth.year ;
}


