package Genea;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(Genea.Init.init) return;

		Genea.Init.setupInheritedAttributes();

		Genea.Init.init = true;

		Genea.Init.init();
		core.Init.init();

		Genea.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(Genea.Init.postInit) return;

		Genea.Init.postInit = true;

		Genea.Init.postInit();
		core.Init.postInit();


		common.Decorator.applyDecorators(Genea.NFirstName.decorators, PfirstName.class);
		common.Decorator.applyDecorators(Genea.NLastName.decorators, PlastName.class);
		common.Decorator.applyDecorators(Genea.NGender.decorators, Pmale.class);
		common.Decorator.applyDecorators(Genea.NGender.decorators, Pfemale.class);
		common.Decorator.applyDecorators(Genea.NYear.decorators, Pyear.class);
		common.Decorator.applyDecorators(Genea.NGeneology.decorators, Pgeneology.class);
		common.Decorator.applyDecorators(Genea.NFamilies.decorators, PoneFamily.class);
		common.Decorator.applyDecorators(Genea.NFamilies.decorators, PconsFamily.class);
		common.Decorator.applyDecorators(Genea.NFamily.decorators, Pfamily.class);
		common.Decorator.applyDecorators(Genea.NParents.decorators, Pparents.class);
		common.Decorator.applyDecorators(Genea.NParent.decorators, Pparent.class);
		common.Decorator.applyDecorators(Genea.NChildren.decorators, PnoChildren.class);
		common.Decorator.applyDecorators(Genea.NChildren.decorators, PsomeChildren.class);
		common.Decorator.applyDecorators(Genea.NChildList.decorators, PoneChild.class);
		common.Decorator.applyDecorators(Genea.NChildList.decorators, PconsChild.class);
		common.Decorator.applyDecorators(Genea.NChild.decorators, Pchild.class);
	}

	private static void setupInheritedAttributes(){
		//	production attribute isF::IOBoolean;
		Genea.Pmain.inheritedAttributes.put("Genea:main:local:isF", new java.util.TreeMap<String, common.Lazy>());
		//	production attribute text::IOString;
		Genea.Pmain.inheritedAttributes.put("Genea:main:local:text", new java.util.TreeMap<String, common.Lazy>());
		//	local attribute tree::Geneology;
		Genea.Pmain.inheritedAttributes.put("Genea:main:local:tree", new java.util.TreeMap<String, common.Lazy>());
	}

	private static void initProductionAttributeDefinitions(){
		Genea.NGender.occurs.add("core:patProdName");
		Genea.NGender.occurs.add("core:patChildList");
		Genea.NYear.occurs.add("core:patProdName");
		Genea.NYear.occurs.add("core:patChildList");
		Genea.NFirstName.occurs.add("core:patProdName");
		Genea.NFirstName.occurs.add("core:patChildList");
		Genea.NLastName.occurs.add("core:patProdName");
		Genea.NLastName.occurs.add("core:patChildList");
		Genea.NGender.occurs.add("Genea:report");
		Genea.NYear.occurs.add("Genea:report");
		Genea.NFirstName.occurs.add("Genea:report");
		Genea.NLastName.occurs.add("Genea:report");
		Genea.NYear.occurs.add("Genea:year");
		//PRODUCTION firstName fn::FirstName ::= n::QuotedString_t
		// fn.report = n.lexeme
		Genea.PfirstName.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(Genea.PfirstName.i_n)).lexeme);
			}
		});
		// fn.patProdName = "Genea:firstName"
		Genea.PfirstName.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:firstName"));
			}
		});
		// fn.patChildList = cons (cast ( n, AnyType ), [])
		Genea.PfirstName.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.PfirstName.i_n)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION lastName ln::LastName ::= n::QuotedString_t
		// ln.report = n.lexeme
		Genea.PlastName.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(Genea.PlastName.i_n)).lexeme);
			}
		});
		// ln.patProdName = "Genea:lastName"
		Genea.PlastName.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:lastName"));
			}
		});
		// ln.patChildList = cons (cast ( n, AnyType ), [])
		Genea.PlastName.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.PlastName.i_n)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION male g::Gender ::= term('Genea:Male_t')
		// g.report = "Male"
		Genea.Pmale.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Male"));
			}
		});
		// g.patProdName = "Genea:male"
		Genea.Pmale.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:male"));
			}
		});
		// g.patChildList = cons (cast ( _G_0, AnyType ), [])
		Genea.Pmale.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pmale.i__G_0)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION female g::Gender ::= term('Genea:Female_t')
		// g.report = "Female"
		Genea.Pfemale.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Female"));
			}
		});
		// g.patProdName = "Genea:female"
		Genea.Pfemale.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:female"));
			}
		});
		// g.patChildList = cons (cast ( _G_0, AnyType ), [])
		Genea.Pfemale.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pfemale.i__G_0)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION year y::Year ::= i::IntLiteral_t
		// y.report = i.lexeme
		Genea.Pyear.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(Genea.Pyear.i_i)).lexeme);
			}
		});
		// y.year = toInt(i.lexeme)
		Genea.Pyear.synthesizedAttributes.put("Genea:year", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (Float.valueOf(((common.StringCatter)((common.TerminalRecord)context.child(Genea.Pyear.i_i)).lexeme).toString()).intValue());
			}
		});
		// y.patProdName = "Genea:year"
		Genea.Pyear.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:year"));
			}
		});
		// y.patChildList = cons (cast ( i, AnyType ), [])
		Genea.Pyear.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pyear.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		Genea.PgParse.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				try{
					return new Genea.Parser_Genea_gParse().parse(new java.io.StringReader(((common.StringCatter)context.child(Genea.PgParse.i_c)).toString()), "_NULL_");
				}catch(edu.umn.cs.melt.copper.runtime.logging.CopperParserException e){ if("1".equals(System.getenv("SILVERTRACE"))) { throw new RuntimeException("An error occured while parsing.", e); } System.err.println("Parse error encountered. (Set SILVERTRACE=1 to unsuppress stack trace.)\n" + e.getMessage()); System.exit(-1); return null; }
				catch(Exception e){throw new RuntimeException("An error occured while parsing.", e);}
			}
		});
		//FUNCTION main IO ::= args::String io1::IO
		// isF = isFile(args, io1)
		Genea.Pmain.localAttributes.put("Genea:main:local:isF", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)new core.PisFile(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(Genea.Pmain.i_args)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)context.child(Genea.Pmain.i_io1)); } })).doReturn());
			}
		});
		// text = readFile(args, isF.io)
		Genea.Pmain.localAttributes.put("Genea:main:local:text", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)new core.PreadFile(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(Genea.Pmain.i_args)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)((common.DecoratedNode)context.local("Genea:main:local:isF")).synthesized("core:io")); } })).doReturn());
			}
		});
		// tree = gParse(text.sValue)
		Genea.Pmain.localAttributes.put("Genea:main:local:tree", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)new Genea.PgParse(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)((common.DecoratedNode)context.local("Genea:main:local:text")).synthesized("core:sValue")); } })).doReturn());
			}
		});
		//	return if ! isF.bValue then error("\n\nFile \"" ++ args ++ "\" not found.\n\n") else print((if tree.errors == "" then "No errors in family history.\n" else "There are errors in family history.\n\n" ++ tree.errors) ++ "\n\n" ++ "Report:\n" ++ tree.report, text.io);
		Genea.Pmain.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((!((Boolean)((common.DecoratedNode)context.local("Genea:main:local:isF")).synthesized("core:bValue"))) ? ((Object)common.Util.error(new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("\n\nFile \""))).append((common.StringCatter)((common.StringCatter)context.child(Genea.Pmain.i_args)))).append((common.StringCatter)(new common.StringCatter("\" not found.\n\n"))).toString())) : ((Object)new core.Pprint(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(((((common.StringCatter)((common.DecoratedNode)context.local("Genea:main:local:tree")).synthesized("Genea:errors")).toString().equals((new common.StringCatter("")).toString())) ? (new common.StringCatter("No errors in family history.\n")) : new common.StringCatter((common.StringCatter)(new common.StringCatter("There are errors in family history.\n\n"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.local("Genea:main:local:tree")).synthesized("Genea:errors")))))).append((common.StringCatter)(new common.StringCatter("\n\n")))).append((common.StringCatter)(new common.StringCatter("Report:\n")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.local("Genea:main:local:tree")).synthesized("Genea:report"))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)((common.DecoratedNode)context.local("Genea:main:local:text")).synthesized("core:io")); } })).doReturn()));
			}
		});
		Genea.NGeneology.occurs.add("Genea:canParse");
		//ASPECT PRODUCTION geneology g ::= fs::Families
		// g.canParse = true
		Genea.Pgeneology.synthesizedAttributes.put("Genea:canParse", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return true;
			}
		});
		Genea.NGeneology.occurs.add("core:patProdName");
		Genea.NGeneology.occurs.add("core:patChildList");
		Genea.NFamilies.occurs.add("core:patProdName");
		Genea.NFamilies.occurs.add("core:patChildList");
		Genea.NFamily.occurs.add("core:patProdName");
		Genea.NFamily.occurs.add("core:patChildList");
		Genea.NParents.occurs.add("core:patProdName");
		Genea.NParents.occurs.add("core:patChildList");
		Genea.NParent.occurs.add("core:patProdName");
		Genea.NParent.occurs.add("core:patChildList");
		Genea.NGeneology.occurs.add("Genea:report");
		Genea.NFamilies.occurs.add("Genea:report");
		Genea.NFamily.occurs.add("Genea:report");
		Genea.NParents.occurs.add("Genea:report");
		Genea.NParent.occurs.add("Genea:report");
		Genea.NGeneology.occurs.add("Genea:isCorrect");
		Genea.NFamilies.occurs.add("Genea:isCorrect");
		Genea.NFamily.occurs.add("Genea:isCorrect");
		Genea.NGeneology.occurs.add("Genea:errors");
		Genea.NFamilies.occurs.add("Genea:errors");
		Genea.NFamily.occurs.add("Genea:errors");
		Genea.NParent.occurs.add("Genea:youngestBirthYear");
		Genea.NParents.occurs.add("Genea:youngestBirthYear");
		Genea.NChildren.occurs.add("Genea:earliestPossibleBirthYear");
		Genea.NChildList.occurs.add("Genea:earliestPossibleBirthYear");
		Genea.NChild.occurs.add("Genea:earliestPossibleBirthYear");
		Genea.NFamilies.occurs.add("Genea:currentYear");
		Genea.NFamily.occurs.add("Genea:currentYear");
		//PRODUCTION geneology g::Geneology ::= fs::Families
		// g.report = "\n" ++ fs.report ++ "\n\n"
		Genea.Pgeneology.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("\n"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pgeneology.i_fs)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("\n\n")));
			}
		});
		// g.isCorrect = fs.isCorrect
		Genea.Pgeneology.synthesizedAttributes.put("Genea:isCorrect", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)((common.DecoratedNode)context.child(Genea.Pgeneology.i_fs)).synthesized("Genea:isCorrect"));
			}
		});
		// g.errors = fs.errors
		Genea.Pgeneology.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pgeneology.i_fs)).synthesized("Genea:errors"));
			}
		});
		// fs.currentYear = 2010
		Genea.Pgeneology.inheritedAttributes.get(Genea.Pgeneology.i_fs).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(2010);
			}
		});
		// g.patProdName = "Genea:geneology"
		Genea.Pgeneology.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:geneology"));
			}
		});
		// g.patChildList = cons (cast ( fs, AnyType ), [])
		Genea.Pgeneology.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pgeneology.i_fs)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION oneFamily fs::Families ::= f::Family
		// fs.report = f.report
		Genea.PoneFamily.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.PoneFamily.i_f)).synthesized("Genea:report"));
			}
		});
		// fs.isCorrect = f.isCorrect
		Genea.PoneFamily.synthesizedAttributes.put("Genea:isCorrect", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)((common.DecoratedNode)context.child(Genea.PoneFamily.i_f)).synthesized("Genea:isCorrect"));
			}
		});
		// fs.errors = f.errors
		Genea.PoneFamily.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.PoneFamily.i_f)).synthesized("Genea:errors"));
			}
		});
		// f.currentYear = fs.currentYear
		Genea.PoneFamily.inheritedAttributes.get(Genea.PoneFamily.i_f).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// fs.patProdName = "Genea:oneFamily"
		Genea.PoneFamily.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:oneFamily"));
			}
		});
		// fs.patChildList = cons (cast ( f, AnyType ), [])
		Genea.PoneFamily.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PoneFamily.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION consFamily fs::Families ::= f::Family rest::Families
		// fs.report = f.report ++ "\n" ++ rest.report
		Genea.PconsFamily.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsFamily.i_f)).synthesized("Genea:report"))).append((common.StringCatter)(new common.StringCatter("\n")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsFamily.i_rest)).synthesized("Genea:report")));
			}
		});
		// fs.isCorrect = f.isCorrect && rest.isCorrect
		Genea.PconsFamily.synthesizedAttributes.put("Genea:isCorrect", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)((common.DecoratedNode)context.child(Genea.PconsFamily.i_f)).synthesized("Genea:isCorrect")) && ((Boolean)((common.DecoratedNode)context.child(Genea.PconsFamily.i_rest)).synthesized("Genea:isCorrect")));
			}
		});
		// fs.errors = f.errors ++ rest.errors
		Genea.PconsFamily.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsFamily.i_f)).synthesized("Genea:errors"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsFamily.i_rest)).synthesized("Genea:errors")));
			}
		});
		// f.currentYear = fs.currentYear
		Genea.PconsFamily.inheritedAttributes.get(Genea.PconsFamily.i_f).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// rest.currentYear = fs.currentYear
		Genea.PconsFamily.inheritedAttributes.get(Genea.PconsFamily.i_rest).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// fs.patProdName = "Genea:consFamily"
		Genea.PconsFamily.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:consFamily"));
			}
		});
		// fs.patChildList = cons (cast ( f, AnyType ), cons (cast ( rest, AnyType ), []))
		Genea.PconsFamily.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PconsFamily.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PconsFamily.i_rest)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION family f::Family ::= p::Parents cs::Children
		// f.report = p.report ++ cs.report
		Genea.Pfamily.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pfamily.i_p)).synthesized("Genea:report"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pfamily.i_cs)).synthesized("Genea:report")));
			}
		});
		// f.isCorrect = cs.errors == ""
		Genea.Pfamily.synthesizedAttributes.put("Genea:isCorrect", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pfamily.i_cs)).synthesized("Genea:errors")).toString().equals((new common.StringCatter("")).toString()));
			}
		});
		// cs.earliestPossibleBirthYear = p.youngestBirthYear + 15
		Genea.Pfamily.inheritedAttributes.get(Genea.Pfamily.i_cs).put("Genea:earliestPossibleBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(Genea.Pfamily.i_p)).synthesized("Genea:youngestBirthYear")) + new Integer(15));
			}
		});
		// f.errors = cs.errors
		Genea.Pfamily.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pfamily.i_cs)).synthesized("Genea:errors"));
			}
		});
		// cs.currentYear = f.currentYear
		Genea.Pfamily.inheritedAttributes.get(Genea.Pfamily.i_cs).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// f.patProdName = "Genea:family"
		Genea.Pfamily.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:family"));
			}
		});
		// f.patChildList = cons (cast ( p, AnyType ), cons (cast ( cs, AnyType ), []))
		Genea.Pfamily.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pfamily.i_p)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pfamily.i_cs)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION parents p::Parents ::= term('Genea:LParen_t') p1::Parent term('Genea:Comma_t') p2::Parent term('Genea:RParen_t')
		// p.report = "Parents: " ++ p1.report ++ "\n     and " ++ p2.report ++ "\n"
		Genea.Pparents.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("Parents: "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparents.i_p1)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("\n     and ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparents.i_p2)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("\n")));
			}
		});
		// p.youngestBirthYear = if p1.youngestBirthYear < p2.youngestBirthYear then p1.youngestBirthYear else p2.youngestBirthYear
		Genea.Pparents.synthesizedAttributes.put("Genea:youngestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(Genea.Pparents.i_p1)).synthesized("Genea:youngestBirthYear")).intValue() < ((Integer)((common.DecoratedNode)context.child(Genea.Pparents.i_p2)).synthesized("Genea:youngestBirthYear")).intValue()) ? ((Integer)((common.DecoratedNode)context.child(Genea.Pparents.i_p1)).synthesized("Genea:youngestBirthYear")) : ((Integer)((common.DecoratedNode)context.child(Genea.Pparents.i_p2)).synthesized("Genea:youngestBirthYear")));
			}
		});
		// p.patProdName = "Genea:parents"
		Genea.Pparents.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:parents"));
			}
		});
		// p.patChildList = cons (cast ( _G_4, AnyType ), cons (cast ( p1, AnyType ), cons (cast ( _G_2, AnyType ), cons (cast ( p2, AnyType ), cons (cast ( _G_0, AnyType ), [])))))
		Genea.Pparents.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pparents.i__G_4)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparents.i_p1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pparents.i__G_2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparents.i_p2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.Pparents.i__G_0)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } }))); } }))); } })));
			}
		});
		//PRODUCTION parent p::Parent ::= first::FirstName last::LastName g::Gender birth::Year
		// p.report = first.report ++ " " ++ last.report ++ " (" ++ g.report ++ "), " ++ "born in " ++ birth.report
		Genea.Pparent.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparent.i_first)).synthesized("Genea:report"))).append((common.StringCatter)(new common.StringCatter(" ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparent.i_last)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter(" (")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparent.i_g)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("), ")))).append((common.StringCatter)(new common.StringCatter("born in ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pparent.i_birth)).synthesized("Genea:report")));
			}
		});
		// p.youngestBirthYear = birth.year
		Genea.Pparent.synthesizedAttributes.put("Genea:youngestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(Genea.Pparent.i_birth)).synthesized("Genea:year"));
			}
		});
		// p.patProdName = "Genea:parent"
		Genea.Pparent.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:parent"));
			}
		});
		// p.patChildList = cons (cast ( first, AnyType ), cons (cast ( last, AnyType ), cons (cast ( g, AnyType ), cons (cast ( birth, AnyType ), []))))
		Genea.Pparent.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparent.i_first)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparent.i_last)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparent.i_g)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pparent.i_birth)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } }))); } })));
			}
		});
		Genea.NChildren.occurs.add("core:patProdName");
		Genea.NChildren.occurs.add("core:patChildList");
		Genea.NChildList.occurs.add("core:patProdName");
		Genea.NChildList.occurs.add("core:patChildList");
		Genea.NChild.occurs.add("core:patProdName");
		Genea.NChild.occurs.add("core:patChildList");
		Genea.NChildren.occurs.add("Genea:report");
		Genea.NChildList.occurs.add("Genea:report");
		Genea.NChild.occurs.add("Genea:report");
		Genea.NChildren.occurs.add("Genea:errors");
		Genea.NChildList.occurs.add("Genea:errors");
		Genea.NChild.occurs.add("Genea:errors");
		Genea.NChildren.occurs.add("Genea:currentYear");
		Genea.NChildList.occurs.add("Genea:currentYear");
		Genea.NChild.occurs.add("Genea:currentYear");
		Genea.NChildList.occurs.add("Genea:numChildren");
		Genea.NChildren.occurs.add("Genea:numChildren");
		Genea.NChildList.occurs.add("Genea:oldestBirthYear");
		Genea.NChildren.occurs.add("Genea:oldestBirthYear");
		Genea.NChild.occurs.add("Genea:birthYear");
		//PRODUCTION noChildren cs::Children ::= 
		// cs.report = " No children.\n"
		Genea.PnoChildren.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter(" No children.\n"));
			}
		});
		// cs.numChildren = 0
		Genea.PnoChildren.synthesizedAttributes.put("Genea:numChildren", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(0);
			}
		});
		// cs.oldestBirthYear = - 1
		Genea.PnoChildren.synthesizedAttributes.put("Genea:oldestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(-new Integer(1).intValue());
			}
		});
		// cs.errors = ""
		Genea.PnoChildren.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter(""));
			}
		});
		// cs.patProdName = "Genea:noChildren"
		Genea.PnoChildren.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:noChildren"));
			}
		});
		// cs.patChildList = [::AnyType]
		Genea.PnoChildren.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION someChildren cs::Children ::= term('Genea:LCurly_t') cl::ChildList term('Genea:RCurly_t')
		// cs.report = " Children: (" ++ toString(cl.numChildren) ++ " oldest born in " ++ toString(cl.oldestBirthYear) ++ ")\n" ++ cl.report
		Genea.PsomeChildren.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter(" Children: ("))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:numChildren"))))))).append((common.StringCatter)(new common.StringCatter(" oldest born in ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:oldestBirthYear"))))))).append((common.StringCatter)(new common.StringCatter(")\n")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:report")));
			}
		});
		// cs.numChildren = cl.numChildren
		Genea.PsomeChildren.synthesizedAttributes.put("Genea:numChildren", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:numChildren"));
			}
		});
		// cs.oldestBirthYear = cl.oldestBirthYear
		Genea.PsomeChildren.synthesizedAttributes.put("Genea:oldestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:oldestBirthYear"));
			}
		});
		// cl.earliestPossibleBirthYear = cs.earliestPossibleBirthYear
		Genea.PsomeChildren.inheritedAttributes.get(Genea.PsomeChildren.i_cl).put("Genea:earliestPossibleBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:earliestPossibleBirthYear"));
			}
		});
		// cs.errors = cl.errors
		Genea.PsomeChildren.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)).synthesized("Genea:errors"));
			}
		});
		// cl.currentYear = cs.currentYear
		Genea.PsomeChildren.inheritedAttributes.get(Genea.PsomeChildren.i_cl).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// cs.patProdName = "Genea:someChildren"
		Genea.PsomeChildren.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:someChildren"));
			}
		});
		// cs.patChildList = cons (cast ( _G_2, AnyType ), cons (cast ( cl, AnyType ), cons (cast ( _G_0, AnyType ), [])))
		Genea.PsomeChildren.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.PsomeChildren.i__G_2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PsomeChildren.i_cl)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.PsomeChildren.i__G_0)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION oneChild cl::ChildList ::= c::Child
		// cl.report = c.report
		Genea.PoneChild.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.PoneChild.i_c)).synthesized("Genea:report"));
			}
		});
		// cl.numChildren = 1
		Genea.PoneChild.synthesizedAttributes.put("Genea:numChildren", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(1);
			}
		});
		// cl.oldestBirthYear = c.birthYear
		Genea.PoneChild.synthesizedAttributes.put("Genea:oldestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(Genea.PoneChild.i_c)).synthesized("Genea:birthYear"));
			}
		});
		// c.earliestPossibleBirthYear = cl.earliestPossibleBirthYear
		Genea.PoneChild.inheritedAttributes.get(Genea.PoneChild.i_c).put("Genea:earliestPossibleBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:earliestPossibleBirthYear"));
			}
		});
		// cl.errors = c.errors
		Genea.PoneChild.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(Genea.PoneChild.i_c)).synthesized("Genea:errors"));
			}
		});
		// c.currentYear = cl.currentYear
		Genea.PoneChild.inheritedAttributes.get(Genea.PoneChild.i_c).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// cl.patProdName = "Genea:oneChild"
		Genea.PoneChild.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:oneChild"));
			}
		});
		// cl.patChildList = cons (cast ( c, AnyType ), [])
		Genea.PoneChild.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PoneChild.i_c)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION consChild cl::ChildList ::= c::Child term('Genea:Comma_t') rest::ChildList
		// cl.report = c.report ++ rest.report
		Genea.PconsChild.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsChild.i_c)).synthesized("Genea:report"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)).synthesized("Genea:report")));
			}
		});
		// cl.numChildren = 1 + rest.numChildren
		Genea.PconsChild.synthesizedAttributes.put("Genea:numChildren", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(new Integer(1) + ((Integer)((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)).synthesized("Genea:numChildren")));
			}
		});
		// cl.oldestBirthYear = if c.birthYear < rest.oldestBirthYear then c.birthYear else rest.oldestBirthYear
		Genea.PconsChild.synthesizedAttributes.put("Genea:oldestBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(Genea.PconsChild.i_c)).synthesized("Genea:birthYear")).intValue() < ((Integer)((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)).synthesized("Genea:oldestBirthYear")).intValue()) ? ((Integer)((common.DecoratedNode)context.child(Genea.PconsChild.i_c)).synthesized("Genea:birthYear")) : ((Integer)((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)).synthesized("Genea:oldestBirthYear")));
			}
		});
		// c.earliestPossibleBirthYear = cl.earliestPossibleBirthYear
		Genea.PconsChild.inheritedAttributes.get(Genea.PconsChild.i_c).put("Genea:earliestPossibleBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:earliestPossibleBirthYear"));
			}
		});
		// rest.earliestPossibleBirthYear = cl.earliestPossibleBirthYear
		Genea.PconsChild.inheritedAttributes.get(Genea.PconsChild.i_rest).put("Genea:earliestPossibleBirthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:earliestPossibleBirthYear"));
			}
		});
		// cl.errors = c.errors ++ rest.errors
		Genea.PconsChild.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsChild.i_c)).synthesized("Genea:errors"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)).synthesized("Genea:errors")));
			}
		});
		// c.currentYear = cl.currentYear
		Genea.PconsChild.inheritedAttributes.get(Genea.PconsChild.i_c).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// rest.currentYear = cl.currentYear
		Genea.PconsChild.inheritedAttributes.get(Genea.PconsChild.i_rest).put("Genea:currentYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.inherited("Genea:currentYear"));
			}
		});
		// cl.patProdName = "Genea:consChild"
		Genea.PconsChild.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:consChild"));
			}
		});
		// cl.patChildList = cons (cast ( c, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( rest, AnyType ), [])))
		Genea.PconsChild.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PconsChild.i_c)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(Genea.PconsChild.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.PconsChild.i_rest)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION child c::Child ::= n::FirstName g::Gender birth::Year
		// c.report = "  " ++ n.report ++ " (" ++ g.report ++ "), " ++ "born in " ++ birth.report ++ " age is " ++ toString(c.currentYear - birth.year) ++ "\n"
		Genea.Pchild.synthesizedAttributes.put("Genea:report", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("  "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pchild.i_n)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter(" (")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pchild.i_g)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("), ")))).append((common.StringCatter)(new common.StringCatter("born in ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pchild.i_birth)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter(" age is ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(new Integer(((Integer)context.inherited("Genea:currentYear")) - ((Integer)((common.DecoratedNode)context.child(Genea.Pchild.i_birth)).synthesized("Genea:year")))))))).append((common.StringCatter)(new common.StringCatter("\n")));
			}
		});
		// c.birthYear = birth.year
		Genea.Pchild.synthesizedAttributes.put("Genea:birthYear", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(Genea.Pchild.i_birth)).synthesized("Genea:year"));
			}
		});
		// c.errors = if c.earliestPossibleBirthYear > birth.year then "Error: Child \"" ++ n.report ++ "\" has incorrect (too early) birth year of " ++ toString(birth.year) ++ ".\n" else ""
		Genea.Pchild.synthesizedAttributes.put("Genea:errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)context.inherited("Genea:earliestPossibleBirthYear")).intValue() > ((Integer)((common.DecoratedNode)context.child(Genea.Pchild.i_birth)).synthesized("Genea:year")).intValue()) ? new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("Error: Child \""))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(Genea.Pchild.i_n)).synthesized("Genea:report")))).append((common.StringCatter)(new common.StringCatter("\" has incorrect (too early) birth year of ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)((common.DecoratedNode)context.child(Genea.Pchild.i_birth)).synthesized("Genea:year"))))))).append((common.StringCatter)(new common.StringCatter(".\n"))) : (new common.StringCatter("")));
			}
		});
		// c.patProdName = "Genea:child"
		Genea.Pchild.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("Genea:child"));
			}
		});
		// c.patChildList = cons (cast ( n, AnyType ), cons (cast ( g, AnyType ), cons (cast ( birth, AnyType ), [])))
		Genea.Pchild.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pchild.i_n)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pchild.i_g)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(Genea.Pchild.i_birth)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
	}

}
