package core;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(core.Init.init) return;

		core.Init.setupInheritedAttributes();

		core.Init.init = true;


		core.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(core.Init.postInit) return;

		core.Init.postInit = true;



		common.Decorator.applyDecorators(core.NStringList.decorators, PemptyString.class);
		common.Decorator.applyDecorators(core.NStringList.decorators, Pempty_string.class);
		common.Decorator.applyDecorators(core.NStringList.decorators, PconsString.class);
		common.Decorator.applyDecorators(core.NStringList.decorators, Pcons_string.class);
		common.Decorator.applyDecorators(core.NAnyTypeList.decorators, Pinternal_nil_AnyTypeList.class);
		common.Decorator.applyDecorators(core.NAnyTypeList.decorators, Pinternal_cons_AnyTypeList.class);
		common.Decorator.applyDecorators(core.NIOBoolean.decorators, PioBoolean.class);
		common.Decorator.applyDecorators(core.NIOString.decorators, PioString.class);
		common.Decorator.applyDecorators(core.NIOInteger.decorators, PioInteger.class);
		common.Decorator.applyDecorators(core.NIOStringList.decorators, PioStringList.class);
		common.Decorator.applyDecorators(core.NHackyParse.decorators, PhackyParser.class);
	}

	private static void setupInheritedAttributes(){
	}

	private static void initProductionAttributeDefinitions(){
		core.NStringList.occurs.add("core:patProdName");
		core.NStringList.occurs.add("core:patChildList");
		core.NStringList.occurs.add("core:sh");
		core.NStringList.occurs.add("core:st");
		core.NStringList.occurs.add("core:empty");
		//PRODUCTION emptyString top::StringList ::= 
		//	forwards to empty_string()
		core.PemptyString.forward = new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new core.Pempty_string());
			}
		};
		// top.patProdName = "core:emptyString"
		core.PemptyString.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:emptyString"));
			}
		});
		// top.patChildList = [::AnyType]
		core.PemptyString.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION empty_string top::StringList ::= 
		// top.empty = true
		core.Pempty_string.synthesizedAttributes.put("core:empty", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return true;
			}
		});
		// top.sh = error("Head not defined on an empty core string list")
		core.Pempty_string.synthesizedAttributes.put("core:sh", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)common.Util.error((new common.StringCatter("Head not defined on an empty core string list")).toString()));
			}
		});
		// top.st = error("Tail not defined on an empty core string list")
		core.Pempty_string.synthesizedAttributes.put("core:st", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Tail not defined on an empty core string list")).toString()));
			}
		});
		// top.patProdName = "core:empty_string"
		core.Pempty_string.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:empty_string"));
			}
		});
		// top.patChildList = [::AnyType]
		core.Pempty_string.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION consString top::StringList ::= h::String t::StringList
		//	forwards to cons_string(h, t)
		core.PconsString.forward = new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new core.Pcons_string(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(core.PconsString.i_h)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(core.PconsString.i_t)).undecorate()); } })));
			}
		};
		// top.patProdName = "core:consString"
		core.PconsString.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:consString"));
			}
		});
		// top.patChildList = cons (cast ( h, AnyType ), cons (cast ( t, AnyType ), []))
		core.PconsString.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(core.PconsString.i_h)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(core.PconsString.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION cons_string top::StringList ::= h::String t::StringList
		// top.empty = false
		core.Pcons_string.synthesizedAttributes.put("core:empty", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return false;
			}
		});
		// top.sh = h
		core.Pcons_string.synthesizedAttributes.put("core:sh", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)context.child(core.Pcons_string.i_h));
			}
		});
		// top.st = t''
		core.Pcons_string.synthesizedAttributes.put("core:st", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(core.Pcons_string.i_t)).undecorate());
			}
		});
		// top.patProdName = "core:cons_string"
		core.Pcons_string.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:cons_string"));
			}
		});
		// top.patChildList = cons (cast ( h, AnyType ), cons (cast ( t, AnyType ), []))
		core.Pcons_string.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(core.Pcons_string.i_h)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(core.Pcons_string.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//FUNCTION indexOf Integer ::= needle::String haystack::String
		//	return error("Not Yet Implemented: indexOf");
		core.PindexOf.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)common.Util.error((new common.StringCatter("Not Yet Implemented: indexOf")).toString()));
			}
		});
		//FUNCTION lastIndexOf Integer ::= needle::String haystack::String
		//	return error("Not Yet Implemented: lastIndexOf");
		core.PlastIndexOf.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)common.Util.error((new common.StringCatter("Not Yet Implemented: lastIndexOf")).toString()));
			}
		});
		//FUNCTION substring String ::= start::Integer endl::Integer str::String
		//	return error("Not Yet Implemented: substring");
		core.Psubstring.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)common.Util.error((new common.StringCatter("Not Yet Implemented: substring")).toString()));
			}
		});
		//FUNCTION startsWith Boolean ::= pre::String s::String
		//	return error("Not Yet Implemented: startsWith");
		core.PstartsWith.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: startsWith")).toString()));
			}
		});
		//FUNCTION endsWith Boolean ::= pre::String s::String
		//	return error("Not Yet Implemented: endsWith");
		core.PendsWith.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: endsWith")).toString()));
			}
		});
		//FUNCTION isDigit Boolean ::= str::String
		//	return error("Not Yet Implemented: isDigit");
		core.PisDigit.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: isDigit")).toString()));
			}
		});
		//FUNCTION isAlpha Boolean ::= str::String
		//	return error("Not Yet Implemented: isAlpha");
		core.PisAlpha.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: isAlpha")).toString()));
			}
		});
		//FUNCTION isSpace Boolean ::= str::String
		//	return error("Not Yet Implemented: isSpace");
		core.PisSpace.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: isSpace")).toString()));
			}
		});
		//FUNCTION isLower Boolean ::= str::String
		//	return error("Not Yet Implemented: isLower");
		core.PisLower.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: isLower")).toString()));
			}
		});
		//FUNCTION isUpper Boolean ::= str::String
		//	return error("Not Yet Implemented: isUpper");
		core.PisUpper.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)common.Util.error((new common.StringCatter("Not Yet Implemented: isUpper")).toString()));
			}
		});
		core.NAnyTypeList.occurs.add("core:patProdName");
		core.NAnyTypeList.occurs.add("core:patChildList");
		core.NAnyTypeList.occurs.add("core:empty_AnyTypeList");
		core.NAnyTypeList.occurs.add("core:head_AnyTypeList");
		core.NAnyTypeList.occurs.add("core:tail_AnyTypeList");
		core.NAnyTypeList.occurs.add("core:length_AnyTypeList");
		//FUNCTION nil_AnyTypeList Decorated AnyTypeList ::= 
		//	return decorate internal_nil_AnyTypeList() with {};
		core.Pnil_AnyTypeList.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((new core.Pinternal_nil_AnyTypeList()).decorate(context));
			}
		});
		//PRODUCTION internal_nil_AnyTypeList l::AnyTypeList ::= 
		// l.empty_AnyTypeList = true
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:empty_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return true;
			}
		});
		// l.length_AnyTypeList = 0
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:length_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(0);
			}
		});
		// l.head_AnyTypeList = error("Accessing head on value of type [ ] not allowed.\n")
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:head_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.AnyType)common.Util.error((new common.StringCatter("Accessing head on value of type [ ] not allowed.\n")).toString()));
			}
		});
		// l.tail_AnyTypeList = error("Accessing tail on value of type [ ] not allowed.\n")
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:tail_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.DecoratedNode)common.Util.error((new common.StringCatter("Accessing tail on value of type [ ] not allowed.\n")).toString()));
			}
		});
		// l.patProdName = "core:internal_nil_AnyTypeList"
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:internal_nil_AnyTypeList"));
			}
		});
		// l.patChildList = [::AnyType]
		core.Pinternal_nil_AnyTypeList.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//FUNCTION cons_AnyTypeList Decorated AnyTypeList ::= h::AnyType t::Decorated AnyTypeList
		//	return decorate internal_cons_AnyTypeList(h, t) with {};
		core.Pcons_AnyTypeList.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((new core.Pinternal_cons_AnyTypeList(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.AnyType)context.child(core.Pcons_AnyTypeList.i_h)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.DecoratedNode)context.child(core.Pcons_AnyTypeList.i_t)); } }))).decorate(context));
			}
		});
		//PRODUCTION internal_cons_AnyTypeList l::AnyTypeList ::= h::AnyType t::Decorated AnyTypeList
		// l.empty_AnyTypeList = false
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:empty_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return false;
			}
		});
		// l.length_AnyTypeList = 1 + t.length_AnyTypeList
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:length_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(new Integer(1) + ((Integer)((common.DecoratedNode)context.child(core.Pinternal_cons_AnyTypeList.i_t)).synthesized("core:length_AnyTypeList")));
			}
		});
		// l.head_AnyTypeList = h
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:head_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.AnyType)context.child(core.Pinternal_cons_AnyTypeList.i_h));
			}
		});
		// l.tail_AnyTypeList = t
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:tail_AnyTypeList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.DecoratedNode)context.child(core.Pinternal_cons_AnyTypeList.i_t));
			}
		});
		// l.patProdName = "core:internal_cons_AnyTypeList"
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:internal_cons_AnyTypeList"));
			}
		});
		// l.patChildList = cons (h, cons (cast ( t, AnyType ), []))
		core.Pinternal_cons_AnyTypeList.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.AnyType)context.child(core.Pinternal_cons_AnyTypeList.i_h)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(core.Pinternal_cons_AnyTypeList.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//FUNCTION append_AnyTypeList Decorated AnyTypeList ::= l1::Decorated AnyTypeList l2::Decorated AnyTypeList
		//	return if l1.empty_AnyTypeList then l2 else cons_AnyTypeList(l1.head_AnyTypeList, append_AnyTypeList(l1.tail_AnyTypeList, l2));
		core.Pappend_AnyTypeList.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)((common.DecoratedNode)context.child(core.Pappend_AnyTypeList.i_l1)).synthesized("core:empty_AnyTypeList")) ? ((common.DecoratedNode)context.child(core.Pappend_AnyTypeList.i_l2)) : ((common.DecoratedNode)new core.Pcons_AnyTypeList(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.AnyType)((common.DecoratedNode)context.child(core.Pappend_AnyTypeList.i_l1)).synthesized("core:head_AnyTypeList")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.DecoratedNode)new core.Pappend_AnyTypeList(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.DecoratedNode)((common.DecoratedNode)context.child(core.Pappend_AnyTypeList.i_l1)).synthesized("core:tail_AnyTypeList")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.DecoratedNode)context.child(core.Pappend_AnyTypeList.i_l2)); } })).doReturn()); } })).doReturn()));
			}
		});
		core.NIOBoolean.occurs.add("core:patProdName");
		core.NIOBoolean.occurs.add("core:patChildList");
		core.NIOBoolean.occurs.add("core:io");
		core.NIOBoolean.occurs.add("core:bValue");
		core.NIOInteger.occurs.add("core:patProdName");
		core.NIOInteger.occurs.add("core:patChildList");
		core.NIOInteger.occurs.add("core:io");
		core.NIOInteger.occurs.add("core:iValue");
		core.NIOString.occurs.add("core:patProdName");
		core.NIOString.occurs.add("core:patChildList");
		core.NIOString.occurs.add("core:io");
		core.NIOString.occurs.add("core:sValue");
		core.NIOStringList.occurs.add("core:patProdName");
		core.NIOStringList.occurs.add("core:patChildList");
		core.NIOStringList.occurs.add("core:io");
		core.NIOStringList.occurs.add("core:stringList");
		//PRODUCTION ioBoolean top::IOBoolean ::= i::IO b::Boolean
		// top.io = i
		core.PioBoolean.synthesizedAttributes.put("core:io", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.child(core.PioBoolean.i_i));
			}
		});
		// top.bValue = b
		core.PioBoolean.synthesizedAttributes.put("core:bValue", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)context.child(core.PioBoolean.i_b));
			}
		});
		// top.patProdName = "core:ioBoolean"
		core.PioBoolean.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:ioBoolean"));
			}
		});
		// top.patChildList = error("Error: cannot pattern match on production or IO types.\n")
		core.PioBoolean.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)common.Util.error((new common.StringCatter("Error: cannot pattern match on production or IO types.\n")).toString()));
			}
		});
		//PRODUCTION ioString top::IOString ::= i::IO s::String
		// top.io = i
		core.PioString.synthesizedAttributes.put("core:io", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.child(core.PioString.i_i));
			}
		});
		// top.sValue = s
		core.PioString.synthesizedAttributes.put("core:sValue", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)context.child(core.PioString.i_s));
			}
		});
		// top.patProdName = "core:ioString"
		core.PioString.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:ioString"));
			}
		});
		// top.patChildList = error("Error: cannot pattern match on production or IO types.\n")
		core.PioString.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)common.Util.error((new common.StringCatter("Error: cannot pattern match on production or IO types.\n")).toString()));
			}
		});
		//PRODUCTION ioInteger top::IOInteger ::= i::IO int::Integer
		// top.io = i
		core.PioInteger.synthesizedAttributes.put("core:io", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.child(core.PioInteger.i_i));
			}
		});
		// top.iValue = int
		core.PioInteger.synthesizedAttributes.put("core:iValue", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(core.PioInteger.i_int));
			}
		});
		// top.patProdName = "core:ioInteger"
		core.PioInteger.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:ioInteger"));
			}
		});
		// top.patChildList = error("Error: cannot pattern match on production or IO types.\n")
		core.PioInteger.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)common.Util.error((new common.StringCatter("Error: cannot pattern match on production or IO types.\n")).toString()));
			}
		});
		//PRODUCTION ioStringList top::IOStringList ::= i::IO sl::StringList
		// top.io = i
		core.PioStringList.synthesizedAttributes.put("core:io", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.child(core.PioStringList.i_i));
			}
		});
		// top.stringList = sl
		core.PioStringList.synthesizedAttributes.put("core:stringList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(core.PioStringList.i_sl)).undecorate());
			}
		});
		// top.patProdName = "core:ioStringList"
		core.PioStringList.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:ioStringList"));
			}
		});
		// top.patChildList = error("Error: cannot pattern match on production or IO types.\n")
		core.PioStringList.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)common.Util.error((new common.StringCatter("Error: cannot pattern match on production or IO types.\n")).toString()));
			}
		});
		//FUNCTION print IO ::= s::String i::IO
		//	return error("Not Yet Implemented: print");
		core.Pprint.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)common.Util.error((new common.StringCatter("Not Yet Implemented: print")).toString()));
			}
		});
		//FUNCTION exit IO ::= val::Integer i::IO
		//	return error("Not Yet Implemented: exit");
		core.Pexit.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)common.Util.error((new common.StringCatter("Not Yet Implemented: exit")).toString()));
			}
		});
		//FUNCTION mkdir IOBoolean ::= s::String i::IO
		//	return error("Not Yet Implemented: mkdir");
		core.Pmkdir.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: mkdir")).toString()));
			}
		});
		//FUNCTION system IOInteger ::= s::String i::IO
		//	return error("Not Yet Implemented: system");
		core.Psystem.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: system")).toString()));
			}
		});
		//FUNCTION writeFile IO ::= file::String contents::String i::IO
		//	return error("Not Yet Implemented: writeFile");
		core.PwriteFile.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)common.Util.error((new common.StringCatter("Not Yet Implemented: writeFile")).toString()));
			}
		});
		//FUNCTION appendFile IO ::= file::String contents::String i::IO
		//	return error("Not Yet Implemented: appendFile");
		core.PappendFile.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)common.Util.error((new common.StringCatter("Not Yet Implemented: appendFile")).toString()));
			}
		});
		//FUNCTION fileTime IOInteger ::= s::String i::IO
		//	return error("Not Yet Implemented: fileTime");
		core.PfileTime.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: fileTime")).toString()));
			}
		});
		//FUNCTION isFile IOBoolean ::= s::String i::IO
		//	return error("Not Yet Implemented: isFile");
		core.PisFile.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: isFile")).toString()));
			}
		});
		//FUNCTION isDirectory IOBoolean ::= s::String i::IO
		//	return error("Not Yet Implemented: isDirectory");
		core.PisDirectory.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: isDirectory")).toString()));
			}
		});
		//FUNCTION readFile IOString ::= s::String i::IO
		//	return error("Not Yet Implemented: readFile");
		core.PreadFile.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: readFile")).toString()));
			}
		});
		//FUNCTION cwd IOString ::= i::IO
		//	return error("Not Yet Implemented: cwd");
		core.Pcwd.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: cwd")).toString()));
			}
		});
		//FUNCTION envVar IOString ::= s::String i::IO
		//	return error("Not Yet Implemented: envVar");
		core.PenvVar.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: envVar")).toString()));
			}
		});
		//FUNCTION listContents IOStringList ::= s::String i::IO
		//	return error("Not Yet Implemented: listContents");
		core.PlistContents.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not Yet Implemented: listContents")).toString()));
			}
		});
		//FUNCTION unsafeio IO ::= 
		//	return error("Not Yet Implemented: unsafeio");
		core.Punsafeio.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)common.Util.error((new common.StringCatter("Not Yet Implemented: unsafeio")).toString()));
			}
		});
		//FUNCTION genInt Integer ::= 
		//	return error("Not Yet Implemented: genInt");
		core.PgenInt.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)common.Util.error((new common.StringCatter("Not Yet Implemented: genInt")).toString()));
			}
		});
		core.NHackyParse.occurs.add("core:patProdName");
		core.NHackyParse.occurs.add("core:patChildList");
		core.NHackyParse.occurs.add("core:parseSuccess");
		core.NHackyParse.occurs.add("core:parseTree");
		core.NHackyParse.occurs.add("core:parseErrors");
		//PRODUCTION hackyParser top::HackyParse ::= succ::Boolean tree::AnyType fail::String
		// top.parseSuccess = succ
		core.PhackyParser.synthesizedAttributes.put("core:parseSuccess", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)context.child(core.PhackyParser.i_succ));
			}
		});
		// top.parseTree = tree
		core.PhackyParser.synthesizedAttributes.put("core:parseTree", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.AnyType)context.child(core.PhackyParser.i_tree));
			}
		});
		// top.parseErrors = fail
		core.PhackyParser.synthesizedAttributes.put("core:parseErrors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)context.child(core.PhackyParser.i_fail));
			}
		});
		// top.patProdName = "core:hackyParser"
		core.PhackyParser.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("core:hackyParser"));
			}
		});
		// top.patChildList = cons (cast ( succ, AnyType ), cons (tree, cons (cast ( fail, AnyType ), [])))
		core.PhackyParser.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Boolean)context.child(core.PhackyParser.i_succ)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.AnyType)context.child(core.PhackyParser.i_tree)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(core.PhackyParser.i_fail)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//FUNCTION hackParse HackyParse ::= pfunc::AnyType dat::String
		//	return error("Not impl");
		core.PhackParse.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)common.Util.error((new common.StringCatter("Not impl")).toString()));
			}
		});
	}

}
