package dc;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(dc.Init.init) return;

		dc.Init.setupInheritedAttributes();

		dc.Init.init = true;

		dc.Init.init();
		core.Init.init();

		dc.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(dc.Init.postInit) return;

		dc.Init.postInit = true;

		dc.Init.postInit();
		core.Init.postInit();


		common.Decorator.applyDecorators(dc.NExpr_c.decorators, Padd_c.class);
		common.Decorator.applyDecorators(dc.NExpr_c.decorators, Psub_c.class);
		common.Decorator.applyDecorators(dc.NExpr_c.decorators, PexprTerm_c.class);
		common.Decorator.applyDecorators(dc.NTerm_c.decorators, Pmul_c.class);
		common.Decorator.applyDecorators(dc.NTerm_c.decorators, Pdiv_c.class);
		common.Decorator.applyDecorators(dc.NTerm_c.decorators, PtermFactor_c.class);
		common.Decorator.applyDecorators(dc.NFactor_c.decorators, Pnested_c.class);
		common.Decorator.applyDecorators(dc.NFactor_c.decorators, PintegerConstant_c.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Padd.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Psub.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Pmul.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Pdiv.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, PintegerConstant.class);
		common.Decorator.applyDecorators(dc.NRoot_c.decorators, Proot_c.class);
		common.Decorator.applyDecorators(dc.NRoot.decorators, Proot.class);
		common.Decorator.applyDecorators(dc.NLogicalExpr_c.decorators, Por_c.class);
		common.Decorator.applyDecorators(dc.NLogicalExpr_c.decorators, PlogicalET_c.class);
		common.Decorator.applyDecorators(dc.NLogicalTerm_c.decorators, Pand_c.class);
		common.Decorator.applyDecorators(dc.NLogicalTerm_c.decorators, PlogicalTF_c.class);
		common.Decorator.applyDecorators(dc.NLogicalFactor_c.decorators, Pnot_c.class);
		common.Decorator.applyDecorators(dc.NLogicalFactor_c.decorators, PlogicalRE_c.class);
		common.Decorator.applyDecorators(dc.NRelationalExpr_c.decorators, PrelationExprExpr_c.class);
		common.Decorator.applyDecorators(dc.NRelationalExpr_c.decorators, Pequality_c.class);
		common.Decorator.applyDecorators(dc.NRelationalExpr_c.decorators, PgreaterThan_c.class);
		common.Decorator.applyDecorators(dc.NRelationalExpr_c.decorators, PlessThan_c.class);
		common.Decorator.applyDecorators(dc.NFactor_c.decorators, PfalseConstant_c.class);
		common.Decorator.applyDecorators(dc.NFactor_c.decorators, PtrueConstant_c.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Pand.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Por.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Pnot.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, Pequality.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, PgreaterThan.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, PlessThan.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, PfalseConstant.class);
		common.Decorator.applyDecorators(dc.NExpr.decorators, PtrueConstant.class);
	}

	private static void setupInheritedAttributes(){
		//	local attribute r_cst::Root_c;
		dc.Pmain.inheritedAttributes.put("dc:main:local:r_cst", new java.util.TreeMap<String, common.Lazy>());
		//	local attribute r_ast::Root;
		dc.Pmain.inheritedAttributes.put("dc:main:local:r_ast", new java.util.TreeMap<String, common.Lazy>());
	}

	private static void initProductionAttributeDefinitions(){
		dc.Pparse.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				try{
					return new dc.Parser_dc_parse().parse(new java.io.StringReader(((common.StringCatter)context.child(dc.Pparse.i_c)).toString()), "_NULL_");
				}catch(edu.umn.cs.melt.copper.runtime.logging.CopperParserException e){ if("1".equals(System.getenv("SILVERTRACE"))) { throw new RuntimeException("An error occured while parsing.", e); } System.err.println("Parse error encountered. (Set SILVERTRACE=1 to unsuppress stack trace.)\n" + e.getMessage()); System.exit(-1); return null; }
				catch(Exception e){throw new RuntimeException("An error occured while parsing.", e);}
			}
		});
		//FUNCTION main IO ::= args::String top::IO
		// r_cst = parse(args)
		dc.Pmain.localAttributes.put("dc:main:local:r_cst", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)new dc.Pparse(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(dc.Pmain.i_args)); } })).doReturn());
			}
		});
		// r_ast = r_cst.ast_Root
		dc.Pmain.localAttributes.put("dc:main:local:r_ast", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.local("dc:main:local:r_cst")).synthesized("dc:ast_Root"));
			}
		});
		//	return print("Command line expression: " ++ args ++ "\n\n" ++ "CST pretty print: " ++ r_cst.pp ++ "\n\n" ++ "AST pretty print: " ++ r_ast.pp ++ "\n\n" ++ "Value: " ++ toString(r_ast.value) ++ "\n\n", top);
		dc.Pmain.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)new core.Pprint(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("Command line expression: "))).append((common.StringCatter)((common.StringCatter)context.child(dc.Pmain.i_args)))).append((common.StringCatter)(new common.StringCatter("\n\n")))).append((common.StringCatter)(new common.StringCatter("CST pretty print: ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.local("dc:main:local:r_cst")).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter("\n\n")))).append((common.StringCatter)(new common.StringCatter("AST pretty print: ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.local("dc:main:local:r_ast")).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter("\n\n")))).append((common.StringCatter)(new common.StringCatter("Value: ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)((common.DecoratedNode)context.local("dc:main:local:r_ast")).synthesized("dc:value"))))))).append((common.StringCatter)(new common.StringCatter("\n\n"))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)context.child(dc.Pmain.i_top)); } })).doReturn());
			}
		});
		dc.NExpr_c.occurs.add("core:patProdName");
		dc.NExpr_c.occurs.add("core:patChildList");
		dc.NTerm_c.occurs.add("core:patProdName");
		dc.NTerm_c.occurs.add("core:patChildList");
		dc.NFactor_c.occurs.add("core:patProdName");
		dc.NFactor_c.occurs.add("core:patChildList");
		dc.NExpr_c.occurs.add("dc:ast_Expr");
		dc.NTerm_c.occurs.add("dc:ast_Expr");
		dc.NFactor_c.occurs.add("dc:ast_Expr");
		dc.NExpr_c.occurs.add("dc:pp");
		dc.NTerm_c.occurs.add("dc:pp");
		dc.NFactor_c.occurs.add("dc:pp");
		//PRODUCTION add_c sum::Expr_c ::= e::Expr_c term('dc:Plus_t') t::Term_c
		// sum.pp = e.pp ++ " + " ++ t.pp
		dc.Padd_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Padd_c.i_e)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" + ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Padd_c.i_t)).synthesized("dc:pp")));
			}
		});
		// sum.ast_Expr = add(e.ast_Expr, t.ast_Expr)
		dc.Padd_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Padd(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Padd_c.i_e)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Padd_c.i_t)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// sum.patProdName = "dc:add_c"
		dc.Padd_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:add_c"));
			}
		});
		// sum.patChildList = cons (cast ( e, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( t, AnyType ), [])))
		dc.Padd_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Padd_c.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Padd_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Padd_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION sub_c dff::Expr_c ::= e::Expr_c term('dc:Dash_t') t::Term_c
		// dff.pp = e.pp ++ " - " ++ t.pp
		dc.Psub_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Psub_c.i_e)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" - ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Psub_c.i_t)).synthesized("dc:pp")));
			}
		});
		// dff.ast_Expr = sub(e.ast_Expr, t.ast_Expr)
		dc.Psub_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Psub(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Psub_c.i_e)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Psub_c.i_t)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// dff.patProdName = "dc:sub_c"
		dc.Psub_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:sub_c"));
			}
		});
		// dff.patChildList = cons (cast ( e, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( t, AnyType ), [])))
		dc.Psub_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Psub_c.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Psub_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Psub_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION exprTerm_c e::Expr_c ::= t::Term_c
		// e.pp = t.pp
		dc.PexprTerm_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PexprTerm_c.i_t)).synthesized("dc:pp"));
			}
		});
		// e.ast_Expr = t.ast_Expr
		dc.PexprTerm_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PexprTerm_c.i_t)).synthesized("dc:ast_Expr"));
			}
		});
		// e.patProdName = "dc:exprTerm_c"
		dc.PexprTerm_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:exprTerm_c"));
			}
		});
		// e.patChildList = cons (cast ( t, AnyType ), [])
		dc.PexprTerm_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PexprTerm_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION mul_c prd::Term_c ::= t::Term_c term('dc:Star_t') f::Factor_c
		// prd.pp = t.pp ++ " * " ++ f.pp
		dc.Pmul_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pmul_c.i_t)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" * ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pmul_c.i_f)).synthesized("dc:pp")));
			}
		});
		// prd.ast_Expr = mul(t.ast_Expr, f.ast_Expr)
		dc.Pmul_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Pmul(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pmul_c.i_t)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pmul_c.i_f)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// prd.patProdName = "dc:mul_c"
		dc.Pmul_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:mul_c"));
			}
		});
		// prd.patChildList = cons (cast ( t, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( f, AnyType ), [])))
		dc.Pmul_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pmul_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pmul_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pmul_c.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION div_c d::Term_c ::= t::Term_c term('dc:Slash_t') f::Factor_c
		// d.pp = t.pp ++ " / " ++ f.pp
		dc.Pdiv_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pdiv_c.i_t)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" / ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pdiv_c.i_f)).synthesized("dc:pp")));
			}
		});
		// d.ast_Expr = div(t.ast_Expr, f.ast_Expr)
		dc.Pdiv_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Pdiv(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pdiv_c.i_t)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pdiv_c.i_f)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// d.patProdName = "dc:div_c"
		dc.Pdiv_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:div_c"));
			}
		});
		// d.patChildList = cons (cast ( t, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( f, AnyType ), [])))
		dc.Pdiv_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pdiv_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pdiv_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pdiv_c.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION termFactor_c t::Term_c ::= f::Factor_c
		// t.pp = f.pp
		dc.PtermFactor_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PtermFactor_c.i_f)).synthesized("dc:pp"));
			}
		});
		// t.ast_Expr = f.ast_Expr
		dc.PtermFactor_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PtermFactor_c.i_f)).synthesized("dc:ast_Expr"));
			}
		});
		// t.patProdName = "dc:termFactor_c"
		dc.PtermFactor_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:termFactor_c"));
			}
		});
		// t.patChildList = cons (cast ( f, AnyType ), [])
		dc.PtermFactor_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PtermFactor_c.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION nested_c e::Factor_c ::= term('dc:LParen_t') inner::LogicalExpr_c term('dc:RParen_t')
		// e.pp = "(" ++ inner.pp ++ ")"
		dc.Pnested_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pnested_c.i_inner)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// e.ast_Expr = inner.ast_Expr
		dc.Pnested_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.Pnested_c.i_inner)).synthesized("dc:ast_Expr"));
			}
		});
		// e.patProdName = "dc:nested_c"
		dc.Pnested_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:nested_c"));
			}
		});
		// e.patChildList = cons (cast ( _G_2, AnyType ), cons (cast ( inner, AnyType ), cons (cast ( _G_0, AnyType ), [])))
		dc.Pnested_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pnested_c.i__G_2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pnested_c.i_inner)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pnested_c.i__G_0)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION integerConstant_c ic::Factor_c ::= i::IntLit_t
		// ic.pp = i.lexeme
		dc.PintegerConstant_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PintegerConstant_c.i_i)).lexeme);
			}
		});
		// ic.ast_Expr = integerConstant(i)
		dc.PintegerConstant_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.PintegerConstant(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.TerminalRecord)context.child(dc.PintegerConstant_c.i_i)); } })));
			}
		});
		// ic.patProdName = "dc:integerConstant_c"
		dc.PintegerConstant_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:integerConstant_c"));
			}
		});
		// ic.patChildList = cons (cast ( i, AnyType ), [])
		dc.PintegerConstant_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PintegerConstant_c.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		dc.NExpr.occurs.add("core:patProdName");
		dc.NExpr.occurs.add("core:patChildList");
		dc.NExpr.occurs.add("dc:pp");
		dc.NExpr.occurs.add("dc:value");
		dc.NExpr.occurs.add("dc:type");
		//PRODUCTION add sum::Expr ::= l::Expr r::Expr
		// sum.pp = "(" ++ l.pp ++ " + " ++ r.pp ++ ")"
		dc.Padd.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Padd.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" + ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Padd.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// sum.value = l.value + r.value
		dc.Padd.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(dc.Padd.i_l)).synthesized("dc:value")) + ((Integer)((common.DecoratedNode)context.child(dc.Padd.i_r)).synthesized("dc:value")));
			}
		});
		// sum.patProdName = "dc:add"
		dc.Padd.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:add"));
			}
		});
		// sum.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Padd.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Padd.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Padd.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION sub dff::Expr ::= l::Expr r::Expr
		// dff.pp = "(" ++ l.pp ++ " - " ++ r.pp ++ ")"
		dc.Psub.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Psub.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" - ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Psub.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// dff.value = l.value - r.value
		dc.Psub.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(dc.Psub.i_l)).synthesized("dc:value")) - ((Integer)((common.DecoratedNode)context.child(dc.Psub.i_r)).synthesized("dc:value")));
			}
		});
		// dff.patProdName = "dc:sub"
		dc.Psub.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:sub"));
			}
		});
		// dff.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Psub.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Psub.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Psub.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION mul prd::Expr ::= l::Expr r::Expr
		// prd.pp = "(" ++ l.pp ++ " * " ++ r.pp ++ ")"
		dc.Pmul.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pmul.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" * ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pmul.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// prd.value = l.value * r.value
		dc.Pmul.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(dc.Pmul.i_l)).synthesized("dc:value")) * ((Integer)((common.DecoratedNode)context.child(dc.Pmul.i_r)).synthesized("dc:value")));
			}
		});
		// prd.patProdName = "dc:mul"
		dc.Pmul.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:mul"));
			}
		});
		// prd.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Pmul.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pmul.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pmul.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION div quo::Expr ::= l::Expr r::Expr
		// quo.pp = "(" ++ l.pp ++ " / " ++ r.pp ++ ")"
		dc.Pdiv.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pdiv.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" / ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pdiv.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// quo.value = toInt(toFloat(l.value) / toFloat(r.value))
		dc.Pdiv.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Float)new Float((((Integer)((Integer)((common.DecoratedNode)context.child(dc.Pdiv.i_l)).synthesized("dc:value"))).floatValue()) / (((Integer)((Integer)((common.DecoratedNode)context.child(dc.Pdiv.i_r)).synthesized("dc:value"))).floatValue()))).intValue());
			}
		});
		// quo.patProdName = "dc:div"
		dc.Pdiv.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:div"));
			}
		});
		// quo.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Pdiv.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pdiv.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pdiv.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION integerConstant e::Expr ::= i::IntLit_t
		// e.pp = i.lexeme
		dc.PintegerConstant.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PintegerConstant.i_i)).lexeme);
			}
		});
		// e.value = toInt(i.lexeme)
		dc.PintegerConstant.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (Float.valueOf(((common.StringCatter)((common.TerminalRecord)context.child(dc.PintegerConstant.i_i)).lexeme).toString()).intValue());
			}
		});
		// e.patProdName = "dc:integerConstant"
		dc.PintegerConstant.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:integerConstant"));
			}
		});
		// e.patChildList = cons (cast ( i, AnyType ), [])
		dc.PintegerConstant.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PintegerConstant.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		dc.NRoot_c.occurs.add("core:patProdName");
		dc.NRoot_c.occurs.add("core:patChildList");
		dc.NRoot_c.occurs.add("dc:pp");
		dc.NRoot_c.occurs.add("dc:ast_Root");
		//PRODUCTION root_c r::Root_c ::= e::LogicalExpr_c
		// r.pp = e.pp
		dc.Proot_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.Proot_c.i_e)).synthesized("dc:pp"));
			}
		});
		// r.ast_Root = root(e.ast_Expr)
		dc.Proot_c.synthesizedAttributes.put("dc:ast_Root", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Proot(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Proot_c.i_e)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// r.patProdName = "dc:root_c"
		dc.Proot_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:root_c"));
			}
		});
		// r.patChildList = cons (cast ( e, AnyType ), [])
		dc.Proot_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Proot_c.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		dc.NRoot.occurs.add("core:patProdName");
		dc.NRoot.occurs.add("core:patChildList");
		dc.NRoot.occurs.add("dc:pp");
		dc.NRoot.occurs.add("dc:value");
		dc.NRoot.occurs.add("dc:type");
		//PRODUCTION root r::Root ::= e::Expr
		// r.pp = e.pp
		dc.Proot.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.Proot.i_e)).synthesized("dc:pp"));
			}
		});
		// r.value = e.value
		dc.Proot.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(dc.Proot.i_e)).synthesized("dc:value"));
			}
		});
		// r.patProdName = "dc:root"
		dc.Proot.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:root"));
			}
		});
		// r.patChildList = cons (cast ( e, AnyType ), [])
		dc.Proot.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Proot.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		dc.NRelationalExpr_c.occurs.add("core:patProdName");
		dc.NRelationalExpr_c.occurs.add("core:patChildList");
		dc.NRelationalExpr_c.occurs.add("dc:pp");
		dc.NRelationalExpr_c.occurs.add("dc:ast_Expr");
		dc.NLogicalExpr_c.occurs.add("core:patProdName");
		dc.NLogicalExpr_c.occurs.add("core:patChildList");
		dc.NLogicalTerm_c.occurs.add("core:patProdName");
		dc.NLogicalTerm_c.occurs.add("core:patChildList");
		dc.NLogicalFactor_c.occurs.add("core:patProdName");
		dc.NLogicalFactor_c.occurs.add("core:patChildList");
		dc.NLogicalExpr_c.occurs.add("dc:pp");
		dc.NLogicalTerm_c.occurs.add("dc:pp");
		dc.NLogicalFactor_c.occurs.add("dc:pp");
		dc.NLogicalExpr_c.occurs.add("dc:ast_Expr");
		dc.NLogicalTerm_c.occurs.add("dc:ast_Expr");
		dc.NLogicalFactor_c.occurs.add("dc:ast_Expr");
		//PRODUCTION or_c le::LogicalExpr_c ::= l::LogicalExpr_c term('dc:Or_t') r::LogicalTerm_c
		// le.pp = l.pp ++ " || " ++ r.pp
		dc.Por_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Por_c.i_l)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" || ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Por_c.i_r)).synthesized("dc:pp")));
			}
		});
		// le.ast_Expr = or(l.ast_Expr, r.ast_Expr)
		dc.Por_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Por(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Por_c.i_l)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Por_c.i_r)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// le.patProdName = "dc:or_c"
		dc.Por_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:or_c"));
			}
		});
		// le.patChildList = cons (cast ( l, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( r, AnyType ), [])))
		dc.Por_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Por_c.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Por_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Por_c.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION logicalET_c le::LogicalExpr_c ::= lt::LogicalTerm_c
		// le.pp = lt.pp
		dc.PlogicalET_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PlogicalET_c.i_lt)).synthesized("dc:pp"));
			}
		});
		// le.ast_Expr = lt.ast_Expr
		dc.PlogicalET_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PlogicalET_c.i_lt)).synthesized("dc:ast_Expr"));
			}
		});
		// le.patProdName = "dc:logicalET_c"
		dc.PlogicalET_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:logicalET_c"));
			}
		});
		// le.patChildList = cons (cast ( lt, AnyType ), [])
		dc.PlogicalET_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlogicalET_c.i_lt)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION and_c lt::LogicalTerm_c ::= l::LogicalTerm_c term('dc:And_t') r::LogicalFactor_c
		// lt.pp = "( " ++ l.pp ++ " && " ++ r.pp ++ " )"
		dc.Pand_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("( "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pand_c.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" && ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pand_c.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" )")));
			}
		});
		// lt.ast_Expr = and(l.ast_Expr, r.ast_Expr)
		dc.Pand_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Pand(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pand_c.i_l)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pand_c.i_r)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// lt.patProdName = "dc:and_c"
		dc.Pand_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:and_c"));
			}
		});
		// lt.patChildList = cons (cast ( l, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( r, AnyType ), [])))
		dc.Pand_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pand_c.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pand_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pand_c.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION logicalTF_c lt::LogicalTerm_c ::= lf::LogicalFactor_c
		// lt.pp = lf.pp
		dc.PlogicalTF_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PlogicalTF_c.i_lf)).synthesized("dc:pp"));
			}
		});
		// lt.ast_Expr = lf.ast_Expr
		dc.PlogicalTF_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PlogicalTF_c.i_lf)).synthesized("dc:ast_Expr"));
			}
		});
		// lt.patProdName = "dc:logicalTF_c"
		dc.PlogicalTF_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:logicalTF_c"));
			}
		});
		// lt.patChildList = cons (cast ( lf, AnyType ), [])
		dc.PlogicalTF_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlogicalTF_c.i_lf)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION not_c lf::LogicalFactor_c ::= term('dc:Not_t') nlf::LogicalFactor_c
		// lf.pp = "! " ++ nlf.pp
		dc.Pnot_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)(new common.StringCatter("! "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pnot_c.i_nlf)).synthesized("dc:pp")));
			}
		});
		// lf.ast_Expr = not(nlf.ast_Expr)
		dc.Pnot_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Pnot(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pnot_c.i_nlf)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// lf.patProdName = "dc:not_c"
		dc.Pnot_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:not_c"));
			}
		});
		// lf.patChildList = cons (cast ( _G_1, AnyType ), cons (cast ( nlf, AnyType ), []))
		dc.Pnot_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pnot_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pnot_c.i_nlf)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION logicalRE_c lf::LogicalFactor_c ::= re::RelationalExpr_c
		// lf.pp = re.pp
		dc.PlogicalRE_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PlogicalRE_c.i_re)).synthesized("dc:pp"));
			}
		});
		// lf.ast_Expr = re.ast_Expr
		dc.PlogicalRE_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PlogicalRE_c.i_re)).synthesized("dc:ast_Expr"));
			}
		});
		// lf.patProdName = "dc:logicalRE_c"
		dc.PlogicalRE_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:logicalRE_c"));
			}
		});
		// lf.patChildList = cons (cast ( re, AnyType ), [])
		dc.PlogicalRE_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlogicalRE_c.i_re)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION relationExprExpr_c re::RelationalExpr_c ::= e::Expr_c
		// re.pp = e.pp
		dc.PrelationExprExpr_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(dc.PrelationExprExpr_c.i_e)).synthesized("dc:pp"));
			}
		});
		// re.ast_Expr = e.ast_Expr
		dc.PrelationExprExpr_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(dc.PrelationExprExpr_c.i_e)).synthesized("dc:ast_Expr"));
			}
		});
		// re.patProdName = "dc:relationExprExpr_c"
		dc.PrelationExprExpr_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:relationExprExpr_c"));
			}
		});
		// re.patChildList = cons (cast ( e, AnyType ), [])
		dc.PrelationExprExpr_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PrelationExprExpr_c.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION equality_c re::RelationalExpr_c ::= l::Expr_c term('dc:EqEq_t') r::Expr_c
		// re.pp = l.pp ++ " == " ++ r.pp
		dc.Pequality_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pequality_c.i_l)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" == ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pequality_c.i_r)).synthesized("dc:pp")));
			}
		});
		// re.ast_Expr = equality(l.ast_Expr, r.ast_Expr)
		dc.Pequality_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.Pequality(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pequality_c.i_l)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.Pequality_c.i_r)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// re.patProdName = "dc:equality_c"
		dc.Pequality_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:equality_c"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( r, AnyType ), [])))
		dc.Pequality_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pequality_c.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.Pequality_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pequality_c.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION greaterThan_c re::RelationalExpr_c ::= l::Expr_c term('dc:GT_t') r::Expr_c
		// re.pp = l.pp ++ " > " ++ r.pp
		dc.PgreaterThan_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_l)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" > ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_r)).synthesized("dc:pp")));
			}
		});
		// re.ast_Expr = greaterThan(l.ast_Expr, r.ast_Expr)
		dc.PgreaterThan_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.PgreaterThan(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_l)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_r)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// re.patProdName = "dc:greaterThan_c"
		dc.PgreaterThan_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:greaterThan_c"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( r, AnyType ), [])))
		dc.PgreaterThan_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PgreaterThan_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PgreaterThan_c.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION lessThan_c re::RelationalExpr_c ::= l::Expr_c term('dc:LT_t') r::Expr_c
		// re.pp = l.pp ++ " < " ++ r.pp
		dc.PlessThan_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PlessThan_c.i_l)).synthesized("dc:pp"))).append((common.StringCatter)(new common.StringCatter(" < ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PlessThan_c.i_r)).synthesized("dc:pp")));
			}
		});
		// re.ast_Expr = lessThan(l.ast_Expr, r.ast_Expr)
		dc.PlessThan_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.PlessThan(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.PlessThan_c.i_l)).synthesized("dc:ast_Expr")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(dc.PlessThan_c.i_r)).synthesized("dc:ast_Expr")); } })));
			}
		});
		// re.patProdName = "dc:lessThan_c"
		dc.PlessThan_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:lessThan_c"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( _G_1, AnyType ), cons (cast ( r, AnyType ), [])))
		dc.PlessThan_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlessThan_c.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PlessThan_c.i__G_1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlessThan_c.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION falseConstant_c fc::Factor_c ::= f::False_t
		// fc.pp = f.lexeme
		dc.PfalseConstant_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PfalseConstant_c.i_f)).lexeme);
			}
		});
		// fc.ast_Expr = falseConstant(f)
		dc.PfalseConstant_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.PfalseConstant(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.TerminalRecord)context.child(dc.PfalseConstant_c.i_f)); } })));
			}
		});
		// fc.patProdName = "dc:falseConstant_c"
		dc.PfalseConstant_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:falseConstant_c"));
			}
		});
		// fc.patChildList = cons (cast ( f, AnyType ), [])
		dc.PfalseConstant_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PfalseConstant_c.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION trueConstant_c tc::Factor_c ::= t::True_t
		// tc.pp = t.lexeme
		dc.PtrueConstant_c.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PtrueConstant_c.i_t)).lexeme);
			}
		});
		// tc.ast_Expr = trueConstant(t)
		dc.PtrueConstant_c.synthesizedAttributes.put("dc:ast_Expr", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new dc.PtrueConstant(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.TerminalRecord)context.child(dc.PtrueConstant_c.i_t)); } })));
			}
		});
		// tc.patProdName = "dc:trueConstant_c"
		dc.PtrueConstant_c.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:trueConstant_c"));
			}
		});
		// tc.patChildList = cons (cast ( t, AnyType ), [])
		dc.PtrueConstant_c.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PtrueConstant_c.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION and re::Expr ::= l::Expr r::Expr
		// re.pp = "(" ++ l.pp ++ " && " ++ r.pp ++ ")"
		dc.Pand.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pand.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" && ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pand.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = l.value * r.value
		dc.Pand.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(dc.Pand.i_l)).synthesized("dc:value")) * ((Integer)((common.DecoratedNode)context.child(dc.Pand.i_r)).synthesized("dc:value")));
			}
		});
		// re.patProdName = "dc:and"
		dc.Pand.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:and"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Pand.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pand.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pand.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION or re::Expr ::= l::Expr r::Expr
		// re.pp = "(" ++ l.pp ++ " || " ++ r.pp ++ ")"
		dc.Por.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Por.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" || ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Por.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = l.value + r.value
		dc.Por.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(((Integer)((common.DecoratedNode)context.child(dc.Por.i_l)).synthesized("dc:value")) + ((Integer)((common.DecoratedNode)context.child(dc.Por.i_r)).synthesized("dc:value")));
			}
		});
		// re.patProdName = "dc:or"
		dc.Por.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:or"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Por.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Por.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Por.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION not re::Expr ::= l::Expr
		// re.pp = "( !" ++ l.pp ++ ")"
		dc.Pnot.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("( !"))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pnot.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = if l.value == 1 then 0 else 1
		dc.Pnot.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(dc.Pnot.i_l)).synthesized("dc:value")).intValue() == new Integer(1).intValue()) ? new Integer(0) : new Integer(1));
			}
		});
		// re.patProdName = "dc:not"
		dc.Pnot.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:not"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), [])
		dc.Pnot.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pnot.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION equality re::Expr ::= l::Expr r::Expr
		// re.pp = "(" ++ l.pp ++ " == " ++ r.pp ++ ")"
		dc.Pequality.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pequality.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" == ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.Pequality.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = if l.value == r.value then 1 else 0
		dc.Pequality.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(dc.Pequality.i_l)).synthesized("dc:value")).intValue() == ((Integer)((common.DecoratedNode)context.child(dc.Pequality.i_r)).synthesized("dc:value")).intValue()) ? new Integer(1) : new Integer(0));
			}
		});
		// re.patProdName = "dc:equality"
		dc.Pequality.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:equality"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.Pequality.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pequality.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.Pequality.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION greaterThan re::Expr ::= l::Expr r::Expr
		// re.pp = "(" ++ l.pp ++ " > " ++ r.pp ++ ")"
		dc.PgreaterThan.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PgreaterThan.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" > ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PgreaterThan.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = if l.value > r.value then 1 else 0
		dc.PgreaterThan.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(dc.PgreaterThan.i_l)).synthesized("dc:value")).intValue() > ((Integer)((common.DecoratedNode)context.child(dc.PgreaterThan.i_r)).synthesized("dc:value")).intValue()) ? new Integer(1) : new Integer(0));
			}
		});
		// re.patProdName = "dc:greaterThan"
		dc.PgreaterThan.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:greaterThan"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.PgreaterThan.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PgreaterThan.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PgreaterThan.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION lessThan re::Expr ::= l::Expr r::Expr
		// re.pp = "(" ++ l.pp ++ " < " ++ r.pp ++ ")"
		dc.PlessThan.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PlessThan.i_l)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(" < ")))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(dc.PlessThan.i_r)).synthesized("dc:pp")))).append((common.StringCatter)(new common.StringCatter(")")));
			}
		});
		// re.value = if l.value < r.value then 1 else 0
		dc.PlessThan.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((((Integer)((common.DecoratedNode)context.child(dc.PlessThan.i_l)).synthesized("dc:value")).intValue() < ((Integer)((common.DecoratedNode)context.child(dc.PlessThan.i_r)).synthesized("dc:value")).intValue()) ? new Integer(1) : new Integer(0));
			}
		});
		// re.patProdName = "dc:lessThan"
		dc.PlessThan.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:lessThan"));
			}
		});
		// re.patChildList = cons (cast ( l, AnyType ), cons (cast ( r, AnyType ), []))
		dc.PlessThan.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlessThan.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(dc.PlessThan.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION falseConstant e::Expr ::= f::False_t
		// e.pp = f.lexeme
		dc.PfalseConstant.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PfalseConstant.i_f)).lexeme);
			}
		});
		// e.value = 0
		dc.PfalseConstant.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(0);
			}
		});
		// e.patProdName = "dc:falseConstant"
		dc.PfalseConstant.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:falseConstant"));
			}
		});
		// e.patChildList = cons (cast ( f, AnyType ), [])
		dc.PfalseConstant.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PfalseConstant.i_f)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION trueConstant e::Expr ::= t::True_t
		// e.pp = t.lexeme
		dc.PtrueConstant.synthesizedAttributes.put("dc:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.TerminalRecord)context.child(dc.PtrueConstant.i_t)).lexeme);
			}
		});
		// e.value = 1
		dc.PtrueConstant.synthesizedAttributes.put("dc:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(1);
			}
		});
		// e.patProdName = "dc:trueConstant"
		dc.PtrueConstant.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("dc:trueConstant"));
			}
		});
		// e.patChildList = cons (cast ( t, AnyType ), [])
		dc.PtrueConstant.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.TerminalRecord)context.child(dc.PtrueConstant.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
	}

}
