package edu.umn.cs.melt.tutorials.expr.abstractsyntax;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.init) return;

		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.setupInheritedAttributes();

		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.init = true;

		edu.umn.cs.melt.tutorials.expr.terminals.Init.init();
		core.Init.init();

		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.initAspectAttributeDefinitions();
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.postInit) return;

		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Init.postInit = true;

		edu.umn.cs.melt.tutorials.expr.terminals.Init.postInit();
		core.Init.postInit();


		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.decorators, PintTypeExpr.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.decorators, PbooleanTypeExpr.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.decorators, PintType.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.decorators, PbooleanType.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.decorators, PerrorType.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.decorators, Proot.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, Plet_expr_typed.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, PidRef.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, Padd.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, Psub.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, Pmul.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, Pdiv.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators, PintegerConstant.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.decorators, Pbind_type.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.decorators, PfoundEnvRes.class);
		common.Decorator.applyDecorators(edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.decorators, PnotfoundEnvRes.class);
	}

	private static void setupInheritedAttributes(){
		//	production attribute id_binding::Binding;
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.inheritedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:let_expr_typed:l_id_binding", new java.util.TreeMap<String, common.Lazy>());
		//	production attribute res::EnvRes;
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.inheritedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res", new java.util.TreeMap<String, common.Lazy>());
	}

	private static void initProductionAttributeDefinitions(){
		//PRODUCTION intTypeExpr te::TypeExpr ::= i::Int_t
		// te.pp = i.lexeme
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.i_i)).synthesized("lexeme"));
			}
		});
		// te.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		// te.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:intTypeExpr"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:intTypeExpr"));
			}
		});
		// te.patChildList = cons (cast ( i, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintTypeExpr.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION booleanTypeExpr te::TypeExpr ::= b::Boolean_t
		// te.pp = b.lexeme
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.i_b)).synthesized("lexeme"));
			}
		});
		// te.typerep = booleanType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanType());
			}
		});
		// te.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:booleanTypeExpr"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:booleanTypeExpr"));
			}
		});
		// te.patChildList = cons (cast ( b, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanTypeExpr.i_b)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION intType tr::TypeRep ::= 
		// tr.pp = "int"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("int"));
			}
		});
		// tr.is_equal = case tr.check_for_equal of intType() => true | _ => false
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:is_equal", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((((common.StringCatter)(((common.Node)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:check_for_equal")).decorate(context)).synthesized("core:patProdName")).toString().equals((new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:intType")).toString())) && true) ? true : (true ? false : (common.Util.error((new common.StringCatter("Error: pattern match failed.\n")).toString()))));
			}
		});
		// tr.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:intType"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:intType"));
			}
		});
		// tr.patChildList = [::AnyType]
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION booleanType tr::TypeRep ::= 
		// tr.pp = "boolean"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("boolean"));
			}
		});
		// tr.is_equal = case tr.check_for_equal of booleanType() => true | _ => false
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:is_equal", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((((common.StringCatter)(((common.Node)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:check_for_equal")).decorate(context)).synthesized("core:patProdName")).toString().equals((new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:booleanType")).toString())) && true) ? true : (true ? false : (common.Util.error((new common.StringCatter("Error: pattern match failed.\n")).toString()))));
			}
		});
		// tr.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:booleanType"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanType.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:booleanType"));
			}
		});
		// tr.patChildList = [::AnyType]
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PbooleanType.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION errorType tr::TypeRep ::= 
		// tr.pp = "error"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PerrorType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("error"));
			}
		});
		// tr.is_equal = case tr.check_for_equal of errorType() => true | _ => false
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PerrorType.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:is_equal", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((((common.StringCatter)(((common.Node)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:check_for_equal")).decorate(context)).synthesized("core:patProdName")).toString().equals((new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errorType")).toString())) && true) ? true : (true ? false : (common.Util.error((new common.StringCatter("Error: pattern match failed.\n")).toString()))));
			}
		});
		// tr.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:errorType"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PerrorType.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errorType"));
			}
		});
		// tr.patChildList = [::AnyType]
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PerrorType.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//FUNCTION equal_types Boolean ::= t1::TypeRep t2::TypeRep
		//	return t1.is_equal;
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Boolean)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types.i_t1)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:is_equal"));
			}
		});
		// t1.check_for_equal = t2
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types.inheritedAttributes.get(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types.i_t1).put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:check_for_equal", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types.i_t2)).undecorate());
			}
		});
		//FUNCTION both_same_type_as Decorated AnyTypeList ::= ltr::TypeRep rtr::TypeRep reqd::TypeRep l::Integer c::Integer
		//	return (if equal_types(ltr, reqd) then [] else [ mk_error(l, c, "left operand is not of type " ++ reqd.pp) ]) ++ (if equal_types(rtr, reqd) then [] else [ mk_error(l, c, "right operand is not of type " ++ reqd.pp) ]);
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((((Boolean)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_ltr)).undecorate()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_reqd)).undecorate()); } })).doReturn()) ? common.ConsCell.nil : new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_l)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_c)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.StringCatter((common.StringCatter)(new common.StringCatter("left operand is not of type "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_reqd)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp")))); } })).doReturn()); } }), common.ConsCell.nil))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((((Boolean)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pequal_types(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_rtr)).undecorate()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_reqd)).undecorate()); } })).doReturn()) ? common.ConsCell.nil : new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_l)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_c)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.StringCatter((common.StringCatter)(new common.StringCatter("right operand is not of type "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as.i_reqd)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp")))); } })).doReturn()); } }), common.ConsCell.nil))); } })));
			}
		});
		//PRODUCTION root r::Root ::= e::Expr
		// r.pp = e.pp
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"));
			}
		});
		// r.value = e.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value"));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors"));
			}
		});
		// r.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:root"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:root"));
			}
		});
		// r.patChildList = cons (cast ( e, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION let_expr_typed l::Expr ::= id::Id_t t::TypeExpr v::Expr body::Expr
		// l.pp = "let " ++ id.lexeme ++ ":" ++ t.pp ++ " = " ++ v.pp ++ " in " ++ body.pp ++ " end"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("let "))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_id)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(":"))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_t)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" = "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_v)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" in "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" end"))));
			}
		});
		// l.value = body.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value"));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_v)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } })));
			}
		});
		// l.typerep = body.typerep
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep"));
			}
		});
		// body.env = [ id_binding ] ++ l.env
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.inheritedAttributes.get(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body).put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:let_expr_typed:l_id_binding")).undecorate()); } }), common.ConsCell.nil); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env")); } })));
			}
		});
		// v.env = l.env
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.inheritedAttributes.get(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_v).put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env"));
			}
		});
		// id_binding = bind_type(id, t.typerep, v.value)
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.localAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:let_expr_typed:l_id_binding", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_id)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_t)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_v)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value")); } })));
			}
		});
		// l.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:let_expr_typed"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:let_expr_typed"));
			}
		});
		// l.patChildList = cons (cast ( id, AnyType ), cons (cast ( t, AnyType ), cons (cast ( v, AnyType ), cons (cast ( body, AnyType ), []))))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_id)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_v)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plet_expr_typed.i_body)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } }))); } })));
			}
		});
		//PRODUCTION idRef e::Expr ::= id::Id_t
		// e.pp = id.lexeme
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)).synthesized("lexeme"));
			}
		});
		// e.value = if ! res.found then - 1 else res.binding.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((!((Boolean)((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res")).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found"))) ? (new Integer(-new Integer(1).intValue())) : ((Integer)(((common.Node)((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res")).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:binding")).decorate(context)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value")));
			}
		});
		// e.typerep = if ! res.found then errorType() else res.binding.typerep
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((!((Boolean)((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res")).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found"))) ? (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PerrorType()) : ((common.Node)(((common.Node)((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res")).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:binding")).decorate(context)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)((common.DecoratedNode)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res")).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found")) ? common.ConsCell.nil : new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)).synthesized("line")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)).synthesized("column")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("identifier "))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(" not declared.")))); } })).doReturn()); } }), common.ConsCell.nil));
			}
		});
		// res = lookup(id.lexeme, e.env)
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.localAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef:l_res", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)).synthesized("lexeme")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)context.inherited("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env")); } })).doReturn());
			}
		});
		// e.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:idRef"));
			}
		});
		// e.patChildList = cons (cast ( id, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PidRef.i_id)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//FUNCTION mk_error String ::= l::Integer c::Integer msg::String
		//	return "Error (line " ++ toString(l) ++ ", column " ++ toString(c) ++ "): " ++ msg;
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("Error (line "))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error.i_l)))))))).append((common.StringCatter)(new common.StringCatter(", column "))))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error.i_c)))))))).append((common.StringCatter)(new common.StringCatter("): "))))).append((common.StringCatter)((common.StringCatter)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmk_error.i_msg))));
			}
		});
		//PRODUCTION add sum::Expr ::= l::Expr op::Plus_t r::Expr
		// sum.pp = "(" ++ l.pp ++ " " ++ op.lexeme ++ " " ++ r.pp ++ ")"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_op)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(")"))));
			}
		});
		// sum.value = l.value + r.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new Integer(((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value")) + ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value"))));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } })));
			}
		});
		// sum.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:add"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:add"));
			}
		});
		// sum.patChildList = cons (cast ( l, AnyType ), cons (cast ( op, AnyType ), cons (cast ( r, AnyType ), [])))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_op)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION sub dff::Expr ::= l::Expr op::Dash_t r::Expr
		// dff.pp = "(" ++ l.pp ++ " " ++ op.lexeme ++ " " ++ r.pp ++ ")"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_op)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(")"))));
			}
		});
		// dff.value = l.value - r.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new Integer(((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value")) - ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value"))));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } })));
			}
		});
		// dff.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:sub"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:sub"));
			}
		});
		// dff.patChildList = cons (cast ( l, AnyType ), cons (cast ( op, AnyType ), cons (cast ( r, AnyType ), [])))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_op)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION mul prd::Expr ::= l::Expr op::Star_t r::Expr
		// prd.pp = "(" ++ l.pp ++ " " ++ op.lexeme ++ " " ++ r.pp ++ ")"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_op)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(")"))));
			}
		});
		// prd.value = l.value * r.value
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new Integer(((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value")) * ((Integer)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value"))));
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } })));
			}
		});
		// prd.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:mul"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:mul"));
			}
		});
		// prd.patChildList = cons (cast ( l, AnyType ), cons (cast ( op, AnyType ), cons (cast ( r, AnyType ), [])))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_op)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION div quo::Expr ::= l::Expr op::Slash_t r::Expr
		// quo.pp = "(" ++ l.pp ++ " " ++ op.lexeme ++ " " ++ r.pp ++ ")"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter((common.StringCatter)(new common.StringCatter("("))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_op)).synthesized("lexeme"))))).append((common.StringCatter)(new common.StringCatter(" "))))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp"))))).append((common.StringCatter)(new common.StringCatter(")"))));
			}
		});
		// quo.value = 9999
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new Integer(9999);
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.AppendCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")); } })));
			}
		});
		// quo.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:div"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:div"));
			}
		});
		// quo.patChildList = cons (cast ( l, AnyType ), cons (cast ( op, AnyType ), cons (cast ( r, AnyType ), [])))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_op)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_r)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION integerConstant e::Expr ::= i::IntLit_t
		// e.pp = i.lexeme
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.i_i)).synthesized("lexeme"));
			}
		});
		// e.value = toInt(i.lexeme)
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (Float.valueOf(((common.StringCatter)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.i_i)).synthesized("lexeme")).toString()).intValue());
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).setBase(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		// e.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:integerConstant"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:integerConstant"));
			}
		});
		// e.patChildList = cons (cast ( i, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//FUNCTION lookup EnvRes ::= n::String e::Decorated AnyTypeList
		//	return if null(e) then notfoundEnvRes() else if n == head(e).ident.lexeme then foundEnvRes(head(e)) else lookup(n, tail (e));
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.ConsCell)((common.ConsCell)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_e))).nil() ? (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PnotfoundEnvRes()) : ((((common.StringCatter)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_n)).toString().equals(((common.StringCatter)((common.Terminal)(((common.Node)((common.ConsCell)((common.ConsCell)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_e))).head()).decorate(context)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:ident")).synthesized("lexeme")).toString())) ? (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.ConsCell)((common.ConsCell)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_e))).head()); } }))) : ((common.Node)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_n)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.ConsCell)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Plookup.i_e))).tail(); } })).doReturn())));
			}
		});
		//PRODUCTION bind_type b::Binding ::= id::Id_t t::TypeRep v::Integer
		// b.ident = id
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:ident", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_id));
			}
		});
		// b.value = v
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_v));
			}
		});
		// b.typerep = t
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_t)).undecorate());
			}
		});
		// b.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:bind_type"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:bind_type"));
			}
		});
		// b.patChildList = cons (cast ( id, AnyType ), cons (cast ( t, AnyType ), cons (cast ( v, AnyType ), [])))
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_id)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_t)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pbind_type.i_v)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//PRODUCTION foundEnvRes r::EnvRes ::= b::Binding
		// r.found = true
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return true;
			}
		});
		// r.binding = b
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:binding", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.i_b)).undecorate());
			}
		});
		// r.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:foundEnvRes"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:foundEnvRes"));
			}
		});
		// r.patChildList = cons (cast ( b, AnyType ), [])
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.PfoundEnvRes.i_b)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION notfoundEnvRes r::EnvRes ::= 
		// r.found = false
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PnotfoundEnvRes.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return false;
			}
		});
		// r.binding = error("Accessing binding when variable not found.")
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PnotfoundEnvRes.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:binding", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (common.Util.error((new common.StringCatter("Accessing binding when variable not found.")).toString()));
			}
		});
		// r.patProdName = "edu:umn:cs:melt:tutorials:expr:abstractsyntax:notfoundEnvRes"
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PnotfoundEnvRes.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("edu:umn:cs:melt:tutorials:expr:abstractsyntax:notfoundEnvRes"));
			}
		});
		// r.patChildList = [::AnyType]
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PnotfoundEnvRes.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
	}

	private static void initAspectAttributeDefinitions(){
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:is_equal");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NTypeRep.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:check_for_equal");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.decorators.add(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Denv.singleton);
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.decorators.add(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Denv.singleton);
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep");
		//ASPECT PRODUCTION root r ::= e::Expr
		// e.env = []
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.inheritedAttributes.get(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e).put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:env", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		// r.typerep = e.typerep
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Proot.i_e)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep"));
			}
		});
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep");
		//ASPECT PRODUCTION add sum ::= l::Expr op::Plus_t r::Expr
		// sum.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		// my_errors = both_same_type_as(l.typerep, r.typerep, intType(), op.line, op.column)
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.localAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:add:l_my_errors", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_op)).synthesized("line")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.i_op)).synthesized("column")); } })).doReturn());
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Padd.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).addPiece(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)context.local("edu:umn:cs:melt:tutorials:expr:abstractsyntax:add:l_my_errors"));
			}
		});
		//ASPECT PRODUCTION sub dff ::= l::Expr op::Dash_t r::Expr
		// dff.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).addPiece(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_op)).synthesized("line")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Psub.i_op)).synthesized("column")); } })).doReturn());
			}
		});
		//ASPECT PRODUCTION mul prd ::= l::Expr op::Star_t r::Expr
		// prd.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).addPiece(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_op)).synthesized("line")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pmul.i_op)).synthesized("column")); } })).doReturn());
			}
		});
		//ASPECT PRODUCTION div quo ::= l::Expr op::Slash_t r::Expr
		// quo.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		if((edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")) == null)
			edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors",  new edu.umn.cs.melt.tutorials.expr.abstractsyntax.CAerrors());
		((common.CollectionAttribute)edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.synthesizedAttributes.get("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors")).addPiece(new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.ConsCell)new edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pboth_same_type_as(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_l)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.DecoratedNode)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_r)).synthesized("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_op)).synthesized("line")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)((common.Terminal)context.child(edu.umn.cs.melt.tutorials.expr.abstractsyntax.Pdiv.i_op)).synthesized("column")); } })).doReturn());
			}
		});
		//ASPECT PRODUCTION integerConstant e ::= i::IntLit_t
		// e.typerep = intType()
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintegerConstant.synthesizedAttributes.put("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new edu.umn.cs.melt.tutorials.expr.abstractsyntax.PintType());
			}
		});
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NRoot.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:pp");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NExpr.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:errors");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:ident");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:value");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NBinding.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:typerep");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.occurs.add("core:patProdName");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.occurs.add("core:patChildList");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:found");
		edu.umn.cs.melt.tutorials.expr.abstractsyntax.NEnvRes.occurs.add("edu:umn:cs:melt:tutorials:expr:abstractsyntax:binding");
	}
}
