package lib.errors;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(lib.errors.Init.init) return;

		lib.errors.Init.setupInheritedAttributes();

		lib.errors.Init.init = true;

		core.Init.init();

		lib.errors.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(lib.errors.Init.postInit) return;

		lib.errors.Init.postInit = true;

		core.Init.postInit();


		common.Decorator.applyDecorators(lib.errors.NLocation.decorators, PmkLocation.class);
		common.Decorator.applyDecorators(lib.errors.NLocation.decorators, PmkLocationFile.class);
		common.Decorator.applyDecorators(lib.errors.NError.decorators, PmsgError.class);
		common.Decorator.applyDecorators(lib.errors.NError.decorators, PmsgErrorLoc.class);
	}

	private static void setupInheritedAttributes(){
	}

	private static void initProductionAttributeDefinitions(){
		lib.errors.NLocation.occurs.add("core:patProdName");
		lib.errors.NLocation.occurs.add("core:patChildList");
		lib.errors.NLocation.occurs.add("lib:errors:lin");
		lib.errors.NLocation.occurs.add("lib:errors:col");
		lib.errors.NLocation.occurs.add("lib:errors:loc_filename");
		lib.errors.NLocation.occurs.add("lib:errors:str_location");
		//PRODUCTION mkLocation loc::Location ::= l::Integer c::Integer
		// loc.lin = l
		lib.errors.PmkLocation.synthesizedAttributes.put("lib:errors:lin", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(lib.errors.PmkLocation.i_l));
			}
		});
		// loc.col = c
		lib.errors.PmkLocation.synthesizedAttributes.put("lib:errors:col", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(lib.errors.PmkLocation.i_c));
			}
		});
		// loc.loc_filename = "<unknown>"
		lib.errors.PmkLocation.synthesizedAttributes.put("lib:errors:loc_filename", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("<unknown>"));
			}
		});
		// loc.str_location = "line: " ++ toString(l) ++ " column: " ++ toString(c) ++ " file: " ++ loc.loc_filename ++ "."
		lib.errors.PmkLocation.synthesizedAttributes.put("lib:errors:str_location", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("line: "))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(lib.errors.PmkLocation.i_l))))))).append((common.StringCatter)(new common.StringCatter(" column: ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(lib.errors.PmkLocation.i_c))))))).append((common.StringCatter)(new common.StringCatter(" file: ")))).append((common.StringCatter)((common.StringCatter)context.synthesized("lib:errors:loc_filename")))).append((common.StringCatter)(new common.StringCatter(".")));
			}
		});
		// loc.patProdName = "lib:errors:mkLocation"
		lib.errors.PmkLocation.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:errors:mkLocation"));
			}
		});
		// loc.patChildList = cons (cast ( l, AnyType ), cons (cast ( c, AnyType ), []))
		lib.errors.PmkLocation.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(lib.errors.PmkLocation.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(lib.errors.PmkLocation.i_c)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION mkLocationFile loc::Location ::= l::Integer c::Integer fn::String
		// loc.lin = l
		lib.errors.PmkLocationFile.synthesizedAttributes.put("lib:errors:lin", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(lib.errors.PmkLocationFile.i_l));
			}
		});
		// loc.col = c
		lib.errors.PmkLocationFile.synthesizedAttributes.put("lib:errors:col", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)context.child(lib.errors.PmkLocationFile.i_c));
			}
		});
		// loc.loc_filename = fn
		lib.errors.PmkLocationFile.synthesizedAttributes.put("lib:errors:loc_filename", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)context.child(lib.errors.PmkLocationFile.i_fn));
			}
		});
		// loc.str_location = "line: " ++ toString(l) ++ " column: " ++ toString(c) ++ " file: " ++ loc.loc_filename ++ "."
		lib.errors.PmkLocationFile.synthesizedAttributes.put("lib:errors:str_location", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("line: "))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(lib.errors.PmkLocationFile.i_l))))))).append((common.StringCatter)(new common.StringCatter(" column: ")))).append((common.StringCatter)(new common.StringCatter(String.valueOf(((Integer)context.child(lib.errors.PmkLocationFile.i_c))))))).append((common.StringCatter)(new common.StringCatter(" file: ")))).append((common.StringCatter)((common.StringCatter)context.synthesized("lib:errors:loc_filename")))).append((common.StringCatter)(new common.StringCatter(".")));
			}
		});
		// loc.patProdName = "lib:errors:mkLocationFile"
		lib.errors.PmkLocationFile.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:errors:mkLocationFile"));
			}
		});
		// loc.patChildList = cons (cast ( l, AnyType ), cons (cast ( c, AnyType ), cons (cast ( fn, AnyType ), [])))
		lib.errors.PmkLocationFile.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(lib.errors.PmkLocationFile.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(lib.errors.PmkLocationFile.i_c)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.errors.PmkLocationFile.i_fn)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//FUNCTION mkNoError Decorated AnyTypeList ::= 
		//	return [::Error];
		lib.errors.PmkNoError.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//FUNCTION mkError Decorated AnyTypeList ::= msg::String
		//	return [ msgError(msg) ];
		lib.errors.PmkError.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new lib.errors.PmsgError(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.PmkError.i_msg)); } }))); } }), common.ConsCell.nil);
			}
		});
		//FUNCTION mkErrorLoc Decorated AnyTypeList ::= l::Location msg::String
		//	return [ msgErrorLoc(l'', msg) ];
		lib.errors.PmkErrorLoc.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new lib.errors.PmsgErrorLoc(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (((common.DecoratedNode)context.child(lib.errors.PmkErrorLoc.i_l)).undecorate()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.PmkErrorLoc.i_msg)); } }))); } }), common.ConsCell.nil);
			}
		});
		//FUNCTION mkErrorLinCol Decorated AnyTypeList ::= l::Integer c::Integer msg::String
		//	return [ msgErrorLoc(mkLocation(l, c), msg) ];
		lib.errors.PmkErrorLinCol.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new lib.errors.PmsgErrorLoc(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new lib.errors.PmkLocation(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(lib.errors.PmkErrorLinCol.i_l)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.child(lib.errors.PmkErrorLinCol.i_c)); } }))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.PmkErrorLinCol.i_msg)); } }))); } }), common.ConsCell.nil);
			}
		});
		//FUNCTION mkErrorIf Decorated AnyTypeList ::= msg::String b::Boolean
		//	return if b then [ msgError(msg) ] else [];
		lib.errors.PmkErrorIf.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)context.child(lib.errors.PmkErrorIf.i_b)) ? new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new lib.errors.PmsgError(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.PmkErrorIf.i_msg)); } }))); } }), common.ConsCell.nil) : common.ConsCell.nil);
			}
		});
		lib.errors.NError.occurs.add("core:patProdName");
		lib.errors.NError.occurs.add("core:patChildList");
		lib.errors.NError.occurs.add("lib:errors:message");
		//PRODUCTION msgError e::Error ::= msg::String
		// e.message = msg
		lib.errors.PmsgError.synthesizedAttributes.put("lib:errors:message", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)context.child(lib.errors.PmsgError.i_msg));
			}
		});
		// e.patProdName = "lib:errors:msgError"
		lib.errors.PmsgError.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:errors:msgError"));
			}
		});
		// e.patChildList = cons (cast ( msg, AnyType ), [])
		lib.errors.PmsgError.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.errors.PmsgError.i_msg)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION msgErrorLoc e::Error ::= l::Location msg::String
		// e.message = "Error: " ++ l.str_location ++ "\n" ++ format_msg(msg)
		lib.errors.PmsgErrorLoc.synthesizedAttributes.put("lib:errors:message", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)(new common.StringCatter("Error: "))).append((common.StringCatter)((common.StringCatter)((common.DecoratedNode)context.child(lib.errors.PmsgErrorLoc.i_l)).synthesized("lib:errors:str_location")))).append((common.StringCatter)(new common.StringCatter("\n")))).append((common.StringCatter)((common.StringCatter)new lib.errors.Pformat_msg(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.PmsgErrorLoc.i_msg)); } })).doReturn()));
			}
		});
		// e.patProdName = "lib:errors:msgErrorLoc"
		lib.errors.PmsgErrorLoc.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:errors:msgErrorLoc"));
			}
		});
		// e.patChildList = cons (cast ( l, AnyType ), cons (cast ( msg, AnyType ), []))
		lib.errors.PmsgErrorLoc.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.errors.PmsgErrorLoc.i_l)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.errors.PmsgErrorLoc.i_msg)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//FUNCTION displayErrors String ::= errs::Decorated AnyTypeList
		//	return if null(errs) then "" else decorate head(errs) with {}.message ++ (if null(tail (errs)) then "" else "\n") ++ displayErrors(tail (errs));
		lib.errors.PdisplayErrors.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.ConsCell)((common.ConsCell)context.child(lib.errors.PdisplayErrors.i_errs))).nil() ? (new common.StringCatter("")) : new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)(((common.Node)((common.ConsCell)((common.ConsCell)context.child(lib.errors.PdisplayErrors.i_errs))).head()).decorate(context)).synthesized("lib:errors:message"))).append((common.StringCatter)((((common.ConsCell)((common.ConsCell)((common.ConsCell)context.child(lib.errors.PdisplayErrors.i_errs))).tail()).nil() ? (new common.StringCatter("")) : (new common.StringCatter("\n")))))).append((common.StringCatter)((common.StringCatter)new lib.errors.PdisplayErrors(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.ConsCell)context.child(lib.errors.PdisplayErrors.i_errs))).tail(); } })).doReturn())));
			}
		});
		//FUNCTION format_msg String ::= str::String
		//	return if length(str) == 0 then "" else if isSpace(str) then "" else if first_newline_index == - 1 then padding ++ str else padding ++ substring(0, first_newline_index, str) ++ (if ! isSpace(rest) then "\n" ++ format_msg(rest) else "");
		lib.errors.Pformat_msg.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((new Integer(((common.StringCatter)((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str))).length())).intValue() == new Integer(0).intValue()) ? (new common.StringCatter("")) : (((Boolean)new core.PisSpace(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str)); } })).doReturn()) ? (new common.StringCatter("")) : ((((Integer)context.local("lib:errors:format_msg:local:first_newline_index")).intValue() == new Integer(-new Integer(1).intValue()).intValue()) ? new common.StringCatter((common.StringCatter)((common.StringCatter)context.local("lib:errors:format_msg:local:padding"))).append((common.StringCatter)((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str))) : new common.StringCatter((common.StringCatter)new common.StringCatter((common.StringCatter)((common.StringCatter)context.local("lib:errors:format_msg:local:padding"))).append((common.StringCatter)((common.StringCatter)new core.Psubstring(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return new Integer(0); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Integer)context.local("lib:errors:format_msg:local:first_newline_index")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str)); } })).doReturn()))).append((common.StringCatter)(((!((Boolean)new core.PisSpace(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.local("lib:errors:format_msg:local:rest")); } })).doReturn())) ? new common.StringCatter((common.StringCatter)(new common.StringCatter("\n"))).append((common.StringCatter)((common.StringCatter)new lib.errors.Pformat_msg(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.local("lib:errors:format_msg:local:rest")); } })).doReturn())) : (new common.StringCatter(""))))))));
			}
		});
		// first_newline_index = indexOf("\n", str)
		lib.errors.Pformat_msg.localAttributes.put("lib:errors:format_msg:local:first_newline_index", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Integer)new core.PindexOf(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.StringCatter("\n")); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str)); } })).doReturn());
			}
		});
		// rest = substring(first_newline_index + 1, length(str), str)
		lib.errors.Pformat_msg.localAttributes.put("lib:errors:format_msg:local:rest", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((common.StringCatter)new core.Psubstring(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return new Integer(((Integer)context.local("lib:errors:format_msg:local:first_newline_index")) + new Integer(1)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new Integer(((common.StringCatter)((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str))).length())); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.errors.Pformat_msg.i_str)); } })).doReturn());
			}
		});
		// padding = "       "
		lib.errors.Pformat_msg.localAttributes.put("lib:errors:format_msg:local:padding", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("       "));
			}
		});
	}

	public static final common.DecoratedNode context = common.TopNode.singleton;
}
