package lib.system.ioaction;

public class Init{

	private static boolean init = false;
	private static boolean postInit = false;

	public static void init(){
		if(lib.system.ioaction.Init.init) return;

		lib.system.ioaction.Init.setupInheritedAttributes();

		lib.system.ioaction.Init.init = true;

		core.Init.init();

		lib.system.ioaction.Init.initProductionAttributeDefinitions();
	}

	public static void postInit(){
		if(lib.system.ioaction.Init.postInit) return;

		lib.system.ioaction.Init.postInit = true;

		core.Init.postInit();


		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PprintString.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PprintInteger.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PwriteString.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PskipIOaction.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PioActionSequence.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PoptionalAction.class);
		common.Decorator.applyDecorators(lib.system.ioaction.NIOaction.decorators, PcondAction.class);
	}

	private static void setupInheritedAttributes(){
		//	local attribute instantiatedTask::IOaction;
		lib.system.ioaction.PperformAction.inheritedAttributes.put("lib:system:ioaction:performAction:local:instantiatedTask", new java.util.TreeMap<String, common.Lazy>());
	}

	private static void initProductionAttributeDefinitions(){
		lib.system.ioaction.NIOaction.occurs.add("core:patProdName");
		lib.system.ioaction.NIOaction.occurs.add("core:patChildList");
		lib.system.ioaction.NIOaction.occurs.add("lib:system:ioaction:ioIn");
		lib.system.ioaction.NIOaction.occurs.add("lib:system:ioaction:ioOut");
		//PRODUCTION printString t::IOaction ::= str::String
		// t.ioOut = print(str, t.ioIn)
		lib.system.ioaction.PprintString.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)new core.Pprint(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.system.ioaction.PprintString.i_str)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)context.inherited("lib:system:ioaction:ioIn")); } })).doReturn());
			}
		});
		// t.patProdName = "lib:system:ioaction:printString"
		lib.system.ioaction.PprintString.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:printString"));
			}
		});
		// t.patChildList = cons (cast ( str, AnyType ), [])
		lib.system.ioaction.PprintString.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.system.ioaction.PprintString.i_str)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION printInteger t::IOaction ::= i::Integer
		// t.ioOut = print(toString(i), t.ioIn)
		lib.system.ioaction.PprintInteger.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)new core.Pprint(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.StringCatter(String.valueOf(((Integer)context.child(lib.system.ioaction.PprintInteger.i_i))))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)context.inherited("lib:system:ioaction:ioIn")); } })).doReturn());
			}
		});
		// t.patProdName = "lib:system:ioaction:printInteger"
		lib.system.ioaction.PprintInteger.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:printInteger"));
			}
		});
		// t.patChildList = cons (cast ( i, AnyType ), [])
		lib.system.ioaction.PprintInteger.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Integer)context.child(lib.system.ioaction.PprintInteger.i_i)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } })));
			}
		});
		//PRODUCTION writeString t::IOaction ::= filename::String str::String
		// t.ioOut = writeFile(filename, str, t.ioIn)
		lib.system.ioaction.PwriteString.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)new core.PwriteFile(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.system.ioaction.PwriteString.i_filename)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.StringCatter)context.child(lib.system.ioaction.PwriteString.i_str)); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((Object)context.inherited("lib:system:ioaction:ioIn")); } })).doReturn());
			}
		});
		// t.patProdName = "lib:system:ioaction:writeString"
		lib.system.ioaction.PwriteString.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:writeString"));
			}
		});
		// t.patChildList = cons (cast ( filename, AnyType ), cons (cast ( str, AnyType ), []))
		lib.system.ioaction.PwriteString.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.system.ioaction.PwriteString.i_filename)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.StringCatter)context.child(lib.system.ioaction.PwriteString.i_str)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION skipIOaction task::IOaction ::= 
		// task.ioOut = task.ioIn
		lib.system.ioaction.PskipIOaction.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.inherited("lib:system:ioaction:ioIn"));
			}
		});
		// task.patProdName = "lib:system:ioaction:skipIOaction"
		lib.system.ioaction.PskipIOaction.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:skipIOaction"));
			}
		});
		// task.patChildList = [::AnyType]
		lib.system.ioaction.PskipIOaction.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return common.ConsCell.nil;
			}
		});
		//PRODUCTION ioActionSequence t::IOaction ::= t1::IOaction t2::IOaction
		// t.ioOut = t2.ioOut
		lib.system.ioaction.PioActionSequence.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)((common.DecoratedNode)context.child(lib.system.ioaction.PioActionSequence.i_t2)).synthesized("lib:system:ioaction:ioOut"));
			}
		});
		// t1.ioIn = t.ioIn
		lib.system.ioaction.PioActionSequence.inheritedAttributes.get(lib.system.ioaction.PioActionSequence.i_t1).put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.inherited("lib:system:ioaction:ioIn"));
			}
		});
		// t2.ioIn = t1.ioOut
		lib.system.ioaction.PioActionSequence.inheritedAttributes.get(lib.system.ioaction.PioActionSequence.i_t2).put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)((common.DecoratedNode)context.child(lib.system.ioaction.PioActionSequence.i_t1)).synthesized("lib:system:ioaction:ioOut"));
			}
		});
		// t.patProdName = "lib:system:ioaction:ioActionSequence"
		lib.system.ioaction.PioActionSequence.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:ioActionSequence"));
			}
		});
		// t.patChildList = cons (cast ( t1, AnyType ), cons (cast ( t2, AnyType ), []))
		lib.system.ioaction.PioActionSequence.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.system.ioaction.PioActionSequence.i_t1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.system.ioaction.PioActionSequence.i_t2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION optionalAction t::IOaction ::= cond::Boolean task::IOaction
		// t.ioOut = if cond then task.ioOut else t.ioIn
		lib.system.ioaction.PoptionalAction.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)context.child(lib.system.ioaction.PoptionalAction.i_cond)) ? ((Object)((common.DecoratedNode)context.child(lib.system.ioaction.PoptionalAction.i_task)).synthesized("lib:system:ioaction:ioOut")) : ((Object)context.inherited("lib:system:ioaction:ioIn")));
			}
		});
		// task.ioIn = t.ioIn
		lib.system.ioaction.PoptionalAction.inheritedAttributes.get(lib.system.ioaction.PoptionalAction.i_task).put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.inherited("lib:system:ioaction:ioIn"));
			}
		});
		// t.patProdName = "lib:system:ioaction:optionalAction"
		lib.system.ioaction.PoptionalAction.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:optionalAction"));
			}
		});
		// t.patChildList = cons (cast ( cond, AnyType ), cons (cast ( task, AnyType ), []))
		lib.system.ioaction.PoptionalAction.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Boolean)context.child(lib.system.ioaction.PoptionalAction.i_cond)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.system.ioaction.PoptionalAction.i_task)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } })));
			}
		});
		//PRODUCTION condAction t::IOaction ::= cond::Boolean t1::IOaction t2::IOaction
		// t.ioOut = if cond then t1.ioOut else t2.ioOut
		lib.system.ioaction.PcondAction.synthesizedAttributes.put("lib:system:ioaction:ioOut", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((Boolean)context.child(lib.system.ioaction.PcondAction.i_cond)) ? ((Object)((common.DecoratedNode)context.child(lib.system.ioaction.PcondAction.i_t1)).synthesized("lib:system:ioaction:ioOut")) : ((Object)((common.DecoratedNode)context.child(lib.system.ioaction.PcondAction.i_t2)).synthesized("lib:system:ioaction:ioOut")));
			}
		});
		// t1.ioIn = t.ioIn
		lib.system.ioaction.PcondAction.inheritedAttributes.get(lib.system.ioaction.PcondAction.i_t1).put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.inherited("lib:system:ioaction:ioIn"));
			}
		});
		// t2.ioIn = t.ioIn
		lib.system.ioaction.PcondAction.inheritedAttributes.get(lib.system.ioaction.PcondAction.i_t2).put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.inherited("lib:system:ioaction:ioIn"));
			}
		});
		// t.patProdName = "lib:system:ioaction:condAction"
		lib.system.ioaction.PcondAction.synthesizedAttributes.put("core:patProdName", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.StringCatter("lib:system:ioaction:condAction"));
			}
		});
		// t.patChildList = cons (cast ( cond, AnyType ), cons (cast ( t1, AnyType ), cons (cast ( t2, AnyType ), [])))
		lib.system.ioaction.PcondAction.synthesizedAttributes.put("core:patChildList", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((Boolean)context.child(lib.system.ioaction.PcondAction.i_cond)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.system.ioaction.PcondAction.i_t1)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.ConsCell(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return (new common.AnyType(((common.DecoratedNode)context.child(lib.system.ioaction.PcondAction.i_t2)))); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return common.ConsCell.nil; } }))); } }))); } })));
			}
		});
		//FUNCTION foldIOactions IOaction ::= tasks::Decorated AnyTypeList
		//	return if null(tasks) then skipIOaction() else ioActionSequence(head(tasks), foldIOactions(tail (tasks)));
		lib.system.ioaction.PfoldIOactions.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.ConsCell)((common.ConsCell)context.child(lib.system.ioaction.PfoldIOactions.i_tasks))).nil() ? (new lib.system.ioaction.PskipIOaction()) : (new lib.system.ioaction.PioActionSequence(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)((common.ConsCell)((common.ConsCell)context.child(lib.system.ioaction.PfoldIOactions.i_tasks))).head()); } }), new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.Node)new lib.system.ioaction.PfoldIOactions(new common.Thunk(context, new common.Lazy() { public Object eval(common.DecoratedNode context) { return ((common.ConsCell)((common.ConsCell)context.child(lib.system.ioaction.PfoldIOactions.i_tasks))).tail(); } })).doReturn()); } }))));
			}
		});
		//FUNCTION performAction IO ::= task::IOaction token::IO
		// instantiatedTask = task
		lib.system.ioaction.PperformAction.localAttributes.put("lib:system:ioaction:performAction:local:instantiatedTask", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return (((common.DecoratedNode)context.child(lib.system.ioaction.PperformAction.i_task)).undecorate());
			}
		});
		// instantiatedTask.ioIn = token
		lib.system.ioaction.PperformAction.inheritedAttributes.get("lib:system:ioaction:performAction:local:instantiatedTask").put("lib:system:ioaction:ioIn", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)context.child(lib.system.ioaction.PperformAction.i_token));
			}
		});
		//	return instantiatedTask.ioOut;
		lib.system.ioaction.PperformAction.synthesizedAttributes.put("__return", new common.Lazy(){
			public Object eval(common.DecoratedNode context) {
				return ((Object)((common.DecoratedNode)context.local("lib:system:ioaction:performAction:local:instantiatedTask")).synthesized("lib:system:ioaction:ioOut"));
			}
		});
	}

	public static final common.DecoratedNode context = common.TopNode.singleton;
}
